/**
 * 
 * 测验主界面
 * 
 * sessionStorage add current_question_number
 * 
 */
$.QuizQuestion.exam = function(){

	var _this = this;
	
	var quiz = null;
	
	var user = null;
	
	var current_question = null;
	
	var question_list = null;
		
	var current_question_render = null;
	
	var behaviour_render = null;
	
	
	this.init = function(){
		
		initData();		
		render();
		initEvent();
		
		//$('audio,video').mediaelementplayer();	
	}
	
	this.reload = function(){
		
		initData();
		render();
		initEvent();
		
		//$('audio,video').mediaelementplayer();
	}
	
	var initData = function(){
		
	
		//初始化试卷
		if($.getData('quiz')){
		
			quiz = JSON.parse($.getData('quiz'));
			
			question_list = quiz.questions;
					
			if($.getData('current_question_number')){
				
				current_question = question_list[parseInt($.getData('current_question_number'))];
				
			}else{
				$.setData('current_question_number',0);
				current_question = question_list[0];
			}
			
			
			//初始化答题behaviour
			if(!$.getData('behaviour'))	$.QuizQuestion.autoConvertBehaviour();
			
			
			//初始化答题记录
			if(!$.getData('quiz_attempt')){
				
				//如果没有试卷答题记录，创建新的空试卷答题记录
				var quiz_attempt = new $.QuizQuestion.quizAttempt();
				quiz_attempt.initEmptyObj();
				
				$.setData('quiz_attempt',JSON.stringify(quiz_attempt));
				
			}
			
			if(!$.getData('question_attempt')){
				
				//如果没有试题答题记录，创建新的空的试题答题记录
				var question_attempt_list = new Array();
				
				for(var i = 0;i<question_list.length;i++){
					
					var question_attempt = new $.QuizQuestion.questionAttempt();					
					question_attempt.initEmptyObj(question_list[i]);
					
					question_attempt_list.push(question_attempt);
				}
				
				$.setData('question_attempt',JSON.stringify(question_attempt_list));
			}
			
			
		}
		
	}
	
	var render = function(){
		
		if(quiz != null && current_question != null && question_list != null){
		
			renderQuestion();
			
			renderBehaviour();
            $('video,audio').mediaelementplayer({
			    success: function (mediaElement, domObject) {
			        var container = $(domObject).parents('.mejs-container');
			        container.find('.mejs-playpause-button,.mejs-overlay-button').click(function () {
			            window.external.play_media(decodeURI(mediaElement.src));
			        });
			    }
			});

		}
	}
	
	var renderQuestion = function(){

		quiz.bgcolor && $('body').css('background-color',quiz.bgcolor);
		
		var html = '';

		switch(current_question.qtype){
			
			case 'multichoice':
				current_question_render = 	new $.QuizQuestion.multichoice();
				break;
			case 'matching':
				current_question_render = new $.QuizQuestion.matching();
				break;	
			case 'gapfilling':
				current_question_render = new $.QuizQuestion.gapfilling();
				break;
			case 'connection':
				current_question_render = new $.QuizQuestion.connection();
				break;
		}
		
		if(current_question_render != null){
			
			html += '<div class="quiz_number"><span>第'+parseInt(parseInt($.getData('current_question_number'))+1)+'题</span>/';
			html += '<span>共'+question_list.length+'题</span></div>';
						
			html += current_question_render.render(current_question, quiz);
						
			$('#exam_content').html(html);						
		
			current_question_render.initEvent(current_question);
		}
	}
	
	var renderBehaviour = function(){
		
		$.QuizQuestion.log('renderBehaviour');
			
		var html = '';
		
		switch($.getData('behaviour')){
			
			case $.QuizQuestion.CLASSBEHAVIOUR:
				behaviour_render = new $.QuizQuestion.classBehaviour();
				break;
			case $.QuizQuestion.FREEDOMBEHAVIOUR:
				behaviour_render = new $.QuizQuestion.freedomBehaviour();
				break;
			case $.QuizQuestion.EXAMBEHAVIOUR:
				behaviour_render = new $.QuizQuestion.examBehaviour();
				break;
			case $.QuizQuestion.ASSIGENMENTBEHAVIOUR:
				behaviour_render = new $.QuizQuestion.assigenmentBehaviour();
				break;
				
		}
		
		
		if(behaviour_render != null){
			
			$.QuizQuestion.log('button render');
			
			var time = behaviour_render.renderTime();			
			html += behaviour_render.render();
			
			$('#exam_buttons').html(html);
			$('#exam_content .quiz_number').after($(time));
			
			behaviour_render.initEvent();
		}
	}
	
	var initEvent = function(){
		
		if($.getData('quiz_list') && !$.getData('from_quiz')){
			
			$('#quit').show();
			$('#quit').click(function(){
				
				$.QuizQuestion.getRecordData();	
								
			});
			
		}
		$(window).resize(function() {
            $.SizeSelfAdaption('#exam_content');	
        });		
	}
	
	var scrollContent;
	
/*	function loaded() {
		scrollContent = new iScroll('exam_content');
	}
	
	document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);
	
	document.addEventListener('DOMContentLoaded', loaded, false);*/
	
}
	
$.QuizQuestion.exam.render = function(){
	
	$.QuizQuestion.currentPage = new $.QuizQuestion.exam();
	$.QuizQuestion.currentPage.init();
}

//线性执行逻辑流程
$(document).ready(function(){
	
	$.QuizQuestion.exam.render();
	$.SizeSelfAdaption('#exam_content');

}); 