/**
 * 
 * 测验主界面
 * 
 * sessionStorage add current_question_number
 * 
 */
$.QuizQuestion.review = function() {

	var _this = this;

	var quiz = null;

	var user = null;

	var current_question = null;

	var question_list = null;

	var current_question_render = null;

	var behaviour_render = null;

	this.init = function() {

		initData();
		render();
		initEvent();

		$('audio,video').mediaelementplayer();
	}

	this.reload = function() {

		initData();
		render();
		initEvent();

		$('audio,video').mediaelementplayer();
	}

	var initData = function() {

		//初始化试卷
		if ($.getData('quiz')) {

			quiz = JSON.parse($.getData('quiz'));

			question_list = quiz.questions;

			if ($.getData('current_question_number')) {

				current_question = question_list[parseInt($
						.getData('current_question_number'))];

			} else {
				$.setData('current_question_number', 0);
				current_question = question_list[0];
			}
		}

		//初始化用户
		if ($.getData('user')) {

			user = JSON.parse($.getData('user'));

		}

		//初始化答题记录
		if ($.getData('quiz') && $.getData('user')) {

			if (!$.getData('quiz_attempt')) {

				//如果没有试卷答题记录，创建新的空试卷答题记录
				var quiz_attempt = new $.QuizQuestion.quizAttempt();
				quiz_attempt.initEmptyObj();

				$.setData('quiz_attempt', JSON.stringify(quiz_attempt));

			}

			if (!$.getData('question_attempt')) {

				//如果没有试题答题记录，创建新的空的试题答题记录
				var question_attempt_list = new Array();

				for (var i = 0;i < question_list.length; i++) {

					var question_attempt = new $.QuizQuestion.questionAttempt();
					question_attempt.initEmptyObj(question_list[i]);

					question_attempt_list.push(question_attempt);
				}

				$.setData('question_attempt', JSON.stringify(question_attempt_list));
			}
		}
	}

	var render = function() {

		if (quiz != null && current_question != null && question_list != null) {

			renderQuestion();

			renderReviewContent();

			renderBehaviour();

		}
	}

	var renderQuestion = function() {

		var html = '';

		switch (current_question.qtype) {

			case 'multichoice' :
				current_question_render = new $.QuizQuestion.multichoice();
				break;
			case 'matching' :
				current_question_render = new $.QuizQuestion.matching();
				break;
			case 'gapfilling' :
				current_question_render = new $.QuizQuestion.gapfilling();
				break;
			case 'connection' :
				current_question_render = new $.QuizQuestion.connection();
				break;
		}

		if (current_question_render != null) {

			html += current_question_render.render(current_question);
			$('#review_content').html(html);
			current_question_render.initEvent(current_question);
		}

		$('.answer_content ul li span.answer :nth-child(1)').attr('disabled','disabled');
		$('ul li').draggable('destroy').droppable('destroy');
		$('ul li span').draggable('destroy');
	}

	var renderReviewContent = function() {

		var html = '';

		var question_attempt_list = JSON.parse($.getData('review_question_attempt'));
		var role = $.getData('role');
		var loc = 0;

		for (var i = 0;i < question_attempt_list.length; i++) {

			if (current_question.id == question_attempt_list[i].question_id) {
				loc = i;
				if (role == $.QuizQuestion.TEACHERROLE) {

					html += '<div class="question_review_content">';
					var right_answer = '';
					
					if (current_question.qtype == 'multichoice') {

						var array1 = current_question.options.answers;
						var array2 = question_attempt_list[i].right_answer.split(',');
						
						for(var n = 0;n<array1.length;n++){
							for(var o = 0;o<array2.length;o++){
								if(array1[n].id == array2[o]){
									right_answer += array1[n].answer+'；';
								}
							}
						}

					} else if (current_question.qtype == 'matching') {
						
						var array1 = question_attempt_list[i].right_answer;
						var array2 = current_question.options.sub_questions;
						var array3 = question_attempt_list[i].notes.sub_question_layout.split(',');
						var array4 = new Array();
						
						for(var n = 0;n<array3.length;n++){
							for(var o = 0;o<array2.length;o++){
								if(array2[o].id == array3[n]){
									for(var l = 0;l<array2[o].sub_answers.length;l++){
										array4.push(array2[o].sub_answers[l]);	
									}	
								}
							}
							
						}
						
						for (var j = 0;j < array1.length; j++) {

							var s = array1[j];
							right_answer += '<BR>子答案：';
							
							for (var k = 0;k < s.length; k++) {
								
								for(var m = 0;m<array4.length;m++){
									if(array4[m].id == s[k]){
										right_answer += '<BR>'+array4[m].answer_text;
									}
								}
																
							}
						}
						
					} else if (current_question.qtype == 'gapfilling') {
						
						right_answer += question_attempt_list[i].right_answer;
						
					}else if (current_question.qtype == 'connection') {
						
						right_answer += question_attempt_list[i].right_answer;
						
					}

					html += '<div class="question_right_answer">正确答案：'
							+ right_answer + '</div>';

					var notes = question_attempt_list[i].notes;
					if (notes != null && notes.comment != null) {

						html += '<div class="question_comment">教师评语：<label value="'
								+ notes.comment + '"/></div>';

					} else {

						html += '<div class="question_comment">教师评语：<label value=""/></div>';
					}

					html += '<div class="question_grade">成绩：<label value="">'+question_attempt_list[i].grade+'</label><span class="novalidate" style="display:none;">请填0-'
							+ current_question.grade_in_quiz
							+ '之间的数字</span><br></div>';

				} else if (role == $.QuizQuestion.STUDENTROLE) {

					html += '<div class="question_review_content">';

					var right_answer = '';
					if (current_question.qtype == 'multichoice') {
						
						var array1 = current_question.options.answers;
						var array2 = question_attempt_list[i].right_answer.split(',');
						
						for(var n = 0;n<array1.length;n++){
							for(var o = 0;o<array2.length;o++){
								if(array1[n].id == array2[o]){
									right_answer += array1[n].answer+'；';
								}
							}
						}
												

					} else if (current_question.qtype == 'matching') {
						
						var array1 = question_attempt_list[i].right_answer;
						var array2 = current_question.options.sub_questions;
						var array3 = question_attempt_list[i].notes.sub_question_layout.split(',');
						var array4 = new Array();
						
						for(var n = 0;n<array3.length;n++){
							for(var o = 0;o<array2.length;o++){
								if(array2[o].id == array3[n]){
									for(var l = 0;l<array2[o].sub_answers.length;l++){
										array4.push(array2[o].sub_answers[l]);	
									}	
								}
							}
							
						}
						
						for (var j = 0;j < array1.length; j++) {

							var s = array1[j];
							right_answer += '<BR>子答案：';
							
							for (var k = 0;k < s.length; k++) {
								
								for(var m = 0;m<array4.length;m++){
									if(array4[m].id == s[k]){
										right_answer += '<BR>'+array4[m].answer_text;
									}
								}
								
						
							}
						}
						
					} else if (current_question.qtype == 'gapfilling') {
						
						right_answer += question_attempt_list[i].right_answer;
						
					} else if (current_question.qtype == 'connection') {
						
						right_answer += question_attempt_list[i].right_answer;
						
					}

					html += '<div class="question_right_answer">正确答案：'
							+ right_answer + '</div>';

					var notes = question_attempt_list[i].notes;
					if (notes != null && notes.comment != null) {
						html += '<div class="question_comment">教师评语：'
								+ notes.comment + '</div>';
					} else {
						html += '<div class="question_comment">教师评语：无</div>';
					}
					html += '<div class="question_grade">成绩：'
							+ question_attempt_list[i].grade + '</div>';
				}
			}
		}

		$('.question_content').append($(html));
		$('.feedback').show();
		$('.feedback_sub').show();
		
	}
	var renderBehaviour = function() {

		$.QuizQuestion.log('renderBehaviour');

		var html = '';

		switch ($.getData('behaviour')) {

			case $.QuizQuestion.CLASSBEHAVIOUR :
				behaviour_render = new $.QuizQuestion.classBehaviour();
				break;
			case $.QuizQuestion.FREEDOMBEHAVIOUR :
				behaviour_render = new $.QuizQuestion.freedomBehaviour();
				break;
			case $.QuizQuestion.EXAMBEHAVIOUR :
				behaviour_render = new $.QuizQuestion.examBehaviour();
				break;
			case $.QuizQuestion.ASSIGENMENTBEHAVIOUR :
				behaviour_render = new $.QuizQuestion.assigenmentBehaviour();
				break;

		}

		if (behaviour_render != null) {

			$.QuizQuestion.log('button render');

			html += behaviour_render.renderPageButton();

			$('#review_buttons').html(html);

			behaviour_render.initPageEvent();
		}
	}

	var initEvent = function() {

		var role = $.getData('role');

		if (role == $.QuizQuestion.TEACHERROLE) {

			$('.question_comment input').change(function() {

				//
					var review_question_attempt = JSON.parse($
							.getData('review_question_attempt'));

					for (var i = 0;i < review_question_attempt.length; i++) {

						if ($('.question_content').attr('question_id') == review_question_attempt[i].question_id) {

							$.QuizQuestion.log('comment---->' + $(this).val());
							review_question_attempt[i].notes.comment = $(this)
									.val();
						}
					}

					$.setData('review_question_attempt', JSON
							.stringify(review_question_attempt));
				});

			$('.question_grade input')
					.change(function() {

						var review_question_attempt = JSON.parse($
								.getData('review_question_attempt'));
						var review_quiz_attempt = JSON.parse($
								.getData('review_quiz_attempt'));

						var original_grade = 0;
						var new_grade = 0;

						$(this).next('.novalidate').hide();

						if (($(this).val().match('^[0-9]+$') != null)
								&& (parseInt($(this).val()) <= parseInt($('.question_content')
										.attr('grade_in_quiz')))) {

							for (var i = 0;i < review_question_attempt.length; i++) {

								if ($('.question_content').attr('question_id') == review_question_attempt[i].question_id) {

									original_grade = parseInt(review_question_attempt[i].grade);
									review_question_attempt[i].grade = $(this)
											.val();
									new_grade = parseInt(review_question_attempt[i].grade);
								}
							}

							//重新计算分数，修改quiz_attempt的总分数
							review_quiz_attempt.sumgrades = parseInt(review_quiz_attempt.sumgrades)
									+ (new_grade - original_grade);

							$.setData('review_question_attempt', JSON
									.stringify(review_question_attempt));
							$.setData('review_quiz_attempt', JSON
									.stringify(review_quiz_attempt));

						} else {

							$(this).next('.novalidate').show();
						}
					});
		}

		if ($.getData('quiz_list') && !$.getData('from_quiz')) {
			$('#quit').show();
			$('#quit').click(function() {

				$.QuizQuestion.getRecordData();

			});
		}
		
		$(window).resize(function() {
            $.SizeSelfAdaption("#review_content");		
        });	
	}

}

$.QuizQuestion.review.render = function() {

	$.QuizQuestion.currentPage = new $.QuizQuestion.review();
	$.QuizQuestion.currentPage.init();
}

//线性执行逻辑流程
$(document).ready(function() {

	$.QuizQuestion.review.render();
	$.SizeSelfAdaption("#review_content");		
});