/*
 * 
 * sessionStorage add|delete   view_status    review
 */

$.QuizQuestion.summary = function(){

	var _this = this;
	
	var quiz = null;
	var review_quiz_attempt = null;
	var question_attempt = null;
	
	this.init = function(){
		
		initData();
		renderSubmitedRecord();
		renderLatestQuizResult();
		renderButtons();
		initButtonEvent();
	}
	
	this.reload = function(){
		
		initData();
		renderSubmitedRecord();
		renderLatestQuizResult();
		renderButtons();
		initButtonEvent();
	}
	
	var initData = function(){
		
		if($.getData('quiz')){
			
			quiz = JSON.parse($.getData('quiz'));
			 	
		}
		
		if($.getData('review_quiz_attempt')){
			
			review_quiz_attempt = JSON.parse($.getData('review_quiz_attempt'));
		}

		if($.getData('question_attempt')){
			
			question_attempt = JSON.parse($.getData('question_attempt'));
		}
		
	}
	
	var showTime = function(obj){
		
		var result = '';
		
		var month = 0;
		if(obj.getMonth() == 0){
			
			month = 12;
			
		}else{
			
			month = obj.getMonth();
		}
		result += obj.getFullYear()+'年'+month+'月'+obj.getDate()+'日 ';
		result += obj.getHours()+':'+obj.getMinutes()+':'+obj.getSeconds();

		
		return result;
	}
	
	var renderSubmitedRecord = function(){
		
		$.QuizQuestion.log('renderSubmitedRecord');
		
		var current_behaviour = $.getData('behaviour'); 
		
		//如果是自由练习模式，不显示
		if(quiz.behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR) return;
		
		//如果是随堂练习模式，直接显示分数和开始时间，结束时间
		if(quiz.behaviour == $.QuizQuestion.CLASSBEHAVIOUR){
			
			$.QuizQuestion.log('class -> freedom');
			
			$('#summary_submited_quiz_record').show();
			$('#summary_quiz_name span').html(quiz.name);
			
			$('#summary_quiz_start_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timestart)*1000)));
			$('#summary_quiz_finish_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timefinish)*1000)));
			
			$('#summary_quiz_sumgrades span').html(review_quiz_attempt.sumgrades + '/' + quiz.sumgrades);
		}
		
		//如果是考试或是作业模式，
		if((quiz.behaviour == $.QuizQuestion.EXAMBEHAVIOUR && current_behaviour == $.QuizQuestion.EXAMBEHAVIOUR)
			|| (quiz.behaviour == $.QuizQuestion.ASSIGENMENTBEHAVIOUR && current_behaviour == $.QuizQuestion.ASSIGENMENTBEHAVIOUR)
		  	){
			
			
			// 在时间限制之前显示开始时间和结束时间，不显示分数，显示为未评分
			$('#summary_submited_quiz_record').show();
			$('#summary_quiz_name span').html(quiz.name);
			
			$('#summary_quiz_start_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timestart)*1000)));
			$('#summary_quiz_finish_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timefinish)*1000)));
			
			$('#summary_quiz_sumgrades span').html('未评分');
		
		}else if((quiz.behaviour == $.QuizQuestion.EXAMBEHAVIOUR && current_behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR)
				||(quiz.behaviour == $.QuizQuestion.ASSIGENMENTBEHAVIOUR && current_behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR)
				){
			
			// 在时间限制之后显示开始时间和结束时间，显示分数
			$('#summary_submited_quiz_record').show();
			$('#summary_quiz_name span').html(quiz.name);
			
			$('#summary_quiz_start_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timestart)*1000)));
			$('#summary_quiz_finish_time span').html(showTime(new Date(parseInt(review_quiz_attempt.timefinish)*1000)));
			
			
			$('#summary_quiz_sumgrades span').html(review_quiz_attempt.sumgrades + '/' + quiz.sumgrades);
		}
		
	}
	
	var renderLatestQuizResult = function(){
		
		$.QuizQuestion.log('renderLatestQuizResult');
		
		//如果当前测验模式为自由练习模式，并且不是为回顾状态时，就会显示		
		if($.getData('view_status') && $.getData('view_status') == 'review'){
			 
			 $.removeData('view_status');
			 return;
			 
		}
				
		var current_behaviour = $.getData('behaviour');
		
		if(current_behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR){
		
			var correct_answer_number = 0;
			var incorrect_answer_number = 0;
			
			for(var i = 0;i<question_attempt.length;i++){
				
					
					if(question_attempt[i].state == 'graderight'){
					
						correct_answer_number ++;
						
					}else{
						
						incorrect_answer_number ++;
					}
				
				
			}
			
			$('#summary_latest_quiz_result').show();
			$('#summary_latest_quiz_result span:first-child').html(quiz.questions.length);			
			$('span.rightanswer').html(correct_answer_number);
			$('#summary_latest_quiz_result span:last-child').html(incorrect_answer_number);
			
		}
	}
	
	var renderButtons = function(){
		
		var current_behaviour = $.getData('behaviour'); 
		var role = $.getData('role');
		
		if(current_behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR && role == $.QuizQuestion.STUDENTROLE){
			
			//如果当前是自由练习模式，并且当前用户为学生时，显示返回答题
			$('.start_button').show();
			
		}
		
		//如果是考试模式或作业模式或课堂练习模式
		if(quiz.behaviour == $.QuizQuestion.EXAMBEHAVIOUR 
		   || quiz.behaviour == $.QuizQuestion.ASSIGENMENTBEHAVIOUR
		   || quiz.behaviour == $.QuizQuestion.CLASSBEHAVIOUR){
		
			if(current_behaviour == $.QuizQuestion.EXAMBEHAVIOUR || current_behaviour == $.QuizQuestion.ASSIGENMENTBEHAVIOUR){
				
				//当前是考试模式或作业模式，显示继续答题
				$('.continue_button').show();
				
			}else if(current_behaviour == $.QuizQuestion.FREEDOMBEHAVIOUR){
				
				//当前是自由练习模式，显示回顾
				$('.review_button').show();
			}
		}
		
	}
	
	var initButtonEvent = function(){
	
		$(window).resize(function() {
            $.SizeSelfAdaption('#summary_content');	
        });	
		
		$('.start_button').click(function(){
			
			//清空答题记录
			$.removeData('quiz_attempt');
			$.removeData('question_attempt');
			
			location.href = 'exam.html';
		});
		
		$('.continue_button').click(function(){
			
			//不用清空答题记录
			
			location.href = 'exam.html';
		})
		
		$('.review_button').click(function(){
			
			//清空答题记录
			$.removeData('quiz_attempt');
			$.removeData('question_attempt');
			
			$.setData('view_status','review');
			location.href = 'review.html';
		});
		
		if($.getData('quiz_list') && !$.getData('from_quiz')){
			$('#quit').show();
			$('#quit').click(function(){
				
				$.QuizQuestion.getRecordData();	
								
			});
		}	
	}
	
}

$.QuizQuestion.summary.render = function(){
	
	$.QuizQuestion.currentPage = new $.QuizQuestion.summary();
	$.QuizQuestion.currentPage.init();
}

//线性执行逻辑流程
$(document).ready(function(){
	$.QuizQuestion.summary.render();
	$.SizeSelfAdaption('#summary_content');		
}); 