$.QuizQuestion.questionAttempt = function(){
	
	var _this = this;
	
	this.id = null;
	this.behaviour = null;
	this.question_id = null;
	this.quiz_attempt_id = null;
	this.question_summary = null;
	this.right_answer = null;
	this.response_summary = null;
	this.timemodified = null;
	this.grade = null;
	this.state = null;
	this.notes = null;
	
	this.initData = function(question_attempt_obj){
		
		if(question_attempt_obj != null){
			
			_this.id = question_attempt_obj.id;
			_this.behaviour = question_attempt_obj.behaviour;
			_this.question_id = question_attempt_obj.question_id;
			_this.quiz_attempt_id = question_attempt_obj.quiz_attempt_id;
			_this.question_summary = question_attempt_obj.question_summary;
			_this.right_answer = question_attempt_obj.right_answer;
			_this.response_summary = question_attempt_obj.response_summary;
			_this.timemodified = question_attempt_obj.timemodified;
			_this.grade = question_attempt_obj.grade;
			_this.state = question_attempt_obj.state;
			_this.notes = question_attempt_obj.notes;		
		}
	}
	
	this.initEmptyObj = function(question_obj){
		
		_this.id = $.QuizQuestion.generateGuid();
		_this.behaviour = $.getData('behaviour');
		_this.question_id = question_obj.id;
		_this.quiz_attempt_id = JSON.parse($.getData('quiz_attempt')).id;
		_this.question_summary = question_obj.text;
		
			
		var right_answer = '';
		
		if(question_obj.qtype == 'multichoice'){
			
			
			for(var i = 0;i<question_obj.options.answers.length;i++){
				if(question_obj.options.answers[i].fraction > 0){
					right_answer += question_obj.options.answers[i].id + ',';
				}  
			}
			
			_this.right_answer = right_answer.substr(0,parseInt(right_answer.length-1));
			
			
		}else if(question_obj.qtype == 'gapfilling'){
			
			for(var i = 0;i<question_obj.options.answers.length;i++){
				right_answer += question_obj.options.answers[i].id + ',';  
			}
			
			_this.right_answer = right_answer.substr(0,parseInt(right_answer.length-1));
			
			
		}else if(question_obj.qtype == 'matching'){
			
			right_answer = new Array();
			
			for(var i = 0;i<question_obj.options.sub_questions.length;i++){
		
				var sub_answers = question_obj.options.sub_questions[i].sub_answers;
				
				if($.isArray(sub_answers)){
					
					single_right_answer = new Array()
					for(var j = 0;j<sub_answers.length;j++){
						
							single_right_answer.push(sub_answers[j].id);
					}
					
					right_answer.push(single_right_answer);				
					
				}
			}
				
			_this.right_answer = right_answer ;
			
		}
				
		_this.response_summary = '';
		_this.grade = 0;
		_this.state = 'todo';
		
	}
	
}