/**
 * 
 * 测验模式逻辑处理   20130725
 * 
 * sessionStorage add tmp_quiz_attempt
 * sessionStorage add tmp_question_attempt
 * sessionStorage add|delete exam_time_limit
 */
 
//随堂练习
$.QuizQuestion.classBehaviour = function(){

	var _this = this;
	
	//随堂练习模式页面的展现
	this.render = function(){
		var html = '';
		html += _this.renderPageButton();//翻页按钮的展现
		html += _this.renderSubmitButton();//提交按钮的展现
		return html;
	}
	
	//时间的展现
	this.renderTime = function(){
		return '';
	}
	
	//翻页按钮的展现
	this.renderPageButton = function(){
		$.QuizQuestion.log('_this.renderPageButton');
		var html = '';
		var current_question_number = parseInt($.getData('current_question_number'));//试题个数也就是页数
		var quiz = JSON.parse($.getData('quiz'));
		//除首页外，显示上一页
		if(current_question_number != 0)	html += '<a class="prev_page_button button_d conner10">上一页</a>';	
		//除尾页外，显示下一页
		if(current_question_number < (quiz.questions.length -1))	html += '<a class="next_page_button button_d conner10">下一页</a>';
		$.QuizQuestion.log(html);
		return html;
	}
	
	//提交按钮的展现
	this.renderSubmitButton = function(){
		var html = '';
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		//在最后一页上面显示”提交“按钮
		if(current_question_number == (quiz.questions.length -1))	html += '<a class="submit_button button_d conner10">提交</a>';
		return html;
	}
	
	//事件初始化
	this.initEvent = function(){
		_this.initPageEvent();
		_this.initSubmitEvent();
	}
	
	//对翻页事件的处理
	this.initPageEvent = function(){
		//点击上一页按钮
		$('.prev_page_button').unbind().bind('click',function(){
			//如果存在多媒体文件，就停止
			resetPlayer();			
			var current_question_number = parseInt($.getData('current_question_number'));	//当前页码	
			$.setData('current_question_number',current_question_number - 1);//当前页码-1
			$.QuizQuestion.currentPage.reload();	//重新载入上一页的题目
			
		});
		
		//点击”下一页“按钮
		$('.next_page_button').unbind().bind('click',function(){
			//如果存在多媒体文件，就停止
			resetPlayer();			
			var current_question_number = parseInt($.getData('current_question_number'));
			$.setData('current_question_number',current_question_number + 1);
			$.QuizQuestion.currentPage.reload();
		});
	}
	
	//点击提交按钮
	this.initSubmitEvent = function(){

		$('.submit_button').unbind().bind('click',function(){
			$.QuizQuestion.log('submit button------in class behavior');
			//如果存在多媒体文件，就停止
			resetPlayer();
			_this.submitData();
		});
	
	}
	
	//提交按钮事件响应   
	this.submitData = function(){
		
		//向PAD发送quiz_attempt数据
		var quiz = JSON.parse($.getData('quiz'));//获得测验
		var quiz_attempt  = JSON.parse($.getData('quiz_attempt'));//获得测验记录
		var question_attempt_list = JSON.parse($.getData('question_attempt'));//获得测验试题答题记录？？question_attempt是某一题的答题记录，怎么能是list
		
		//向PAD发送question_attempt数据，如果该试题没有回答，就模拟空记录加入到question_attempt中
		quiz = JSON.parse($.getData('quiz'));
		question_list = quiz.questions;//测验中的试题列表   答题记录中的试题列表和测验中的试题列表可能不一样，因为有可能有的题没有答
		
		quiz_attempt.submited = 1;
		//getTime 返回 1970 年 1 月 1 日至今的毫秒数。
		//测验最后的修改时间
		//测验完成时间
		quiz_attempt.timemodified = parseInt(new Date().getTime()/1000);
		quiz_attempt.timefinish = parseInt(new Date().getTime()/1000);
		//计算测验成绩
		for(var m = 0;m<question_attempt_list.length;m++){//遍历答题试题答题记录列表
			quiz_attempt.sumgrades += question_attempt_list[m].grade;//累加每一道题的成绩
		}
		
		//遍历测验中的试题列表
		for(var i = 0;i<question_list.length;i++){
			//遍历试题答题记录列表
			for(var j = 0;j<question_attempt_list.length;j++){
				//如果两个列表中的题目匹配上，并且答题最终结果状态未定
				if((question_list[i].id == question_attempt_list[j].question_id) && (question_attempt_list[j].state == 'todo')){
					var right_answer = '';
					var user_answers= new Array();
					//对于选择题
					if(question_list[i].options.qtype == 'multichoice'){
						for(var k = 0;k<question_list[i].options.answers.length;k++){//遍历该题配置选项中所有备选答案
							//如果该选项的比重不为0，证明该选项是答案，则将答案记录到right_answer中
							if(question_list[i].options.answers[k].fraction!= 0) right_answer+=question_list[i].options.answers[k].answer + ',';
						}
					}
					//对于匹配题
					else if(question_list[i].options.qtype == 'matching'){
						
						for(var k = 0;k<question_list[i].options.sub_questions.length;k++){//遍历匹配题的所有子问题
							//将答案记录到right_answer中
							right_answer += question_list[i].options.sub_questions[k].answer_text + ',';
						}
					}
					//如果是填空题 
					else if(question_list[i].qtype == 'gapfilling'){
						//保存正确答案	
						console.log('save gapfilling on  classBehaviour');						
					}else if(question_list[i].qtype == 'connection'){
						//保存正确答案	
						console.log('save connection on classBehaviour');						
					}
					
					question_attempt_list[j].right_answer = right_answer.substr(0,parseInt(right_answer.length-1));					
					question_attempt_list[j].response_summary = '';					
					question_attempt_list[j].timemodified = parseInt(new Date().getTime()/1000);
					question_attempt_list[j].state = 'gradewrong';
					question_attempt_list[j].notes = ''; 					
				}
			}	
		}
		
		$.setData('tmp_quiz_attempt',JSON.stringify(quiz_attempt));
		$.setData('tmp_question_attempt',JSON.stringify(question_attempt_list));
	
		if($.QuizQuestion.development == false && !$.getData('from_quiz')){
			
			//向PAD发送请求
			var request = new $.request();
			request.action = 'submit_record';		
			request.params.quiz_id = quiz.id;			
			request.params.quiz_attempt = Base64.encode(JSON.stringify(quiz_attempt));
			request.params.question_attempt = Base64.encode(JSON.stringify(question_attempt_list));
			request.params.quiz_attempt_id = quiz_attempt.id;
			request.params.finish_time = quiz_attempt.timefinish;				
			request.sendRequest();	
			
		}else{
			
			$.QuizQuestion.SyncAttemptData('submit_record',1);	
		}
	}	
}


//自由练习
$.QuizQuestion.freedomBehaviour = function(){

	var _this = this;
	
	
	this.render = function(){
		
		var html = '';
		
		html += _this.renderPageButton();
		html += renderCheckButton();
		
		return html;
	}
	
	this.renderTime = function(){
				
		return '';
	}
	
	this.renderPageButton = function(){
		
		$.QuizQuestion.log('_this.renderPageButton');
		
		var html = '';
		
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		
		if(current_question_number != 0)	html += '<a class="prev_page_button button_d conner10">上一页</a>';	
//		if(current_question_number < (quiz.questions.length -1))	html += '<a class="next_page_button">下一页</a>';
		//自由答题模式最后一道题上面也有下一页，是答题反馈页面。即每一页都有“下一题”按钮
		html += '<a class="next_page_button button_d conner10">下一页</a>';
		
		$.QuizQuestion.log(html);
		return html;
	}
	
	var renderCheckButton = function(){
		
		var html = '';
		
		html += '<a class="check_button button_d conner10">核对答案</a>';
		html += '<a class="clear_button button_d conner10" style="display:none;">清除答案</a>';
		html += '<a class="again_button button_d conner10" style="display:none;">再做一次</a>';      
		
		return html;
	}
	
	
	this.initEvent = function(){
	
		_this.initPageEvent();
		initCheckEvent();
		initAnswerClearEvent();
		initAnswerAgainEvent();
	}
	
	//翻页事件
	this.initPageEvent = function(){
	
		$('.prev_page_button').unbind().bind('click',function(){
			
			//如果存在多媒体文件，就停止
			resetPlayer();			
			var current_question_number = parseInt($.getData('current_question_number'));
		
			$.setData('current_question_number',current_question_number - 1);
			$.QuizQuestion.currentPage.reload();
			
		});
		
		$('.next_page_button').unbind().bind('click',function(){
			
			//如果存在多媒体文件，就停止
			resetPlayer();
			
			
			var quiz = JSON.parse($.getData('quiz'));
			var current_question_number = parseInt($.getData('current_question_number'));
			//最后一页反反馈页面
			if(quiz.questions.length -1 == current_question_number){
				
				$.removeData('current_question_number');
				location.href = 'summary.html';	
				
			}else{
				$.setData('current_question_number',current_question_number + 1);
				$.QuizQuestion.currentPage.reload();
			}
			
		});
	}	
	
	//核对答案
	var initCheckEvent = function(){
		
		$('.check_button').unbind().bind('click',function(){
			
			$.QuizQuestion.log('check_button');
			
			//如果有多媒体文件，停止播放
			resetPlayer();
			
			var quiz = JSON.parse($.getData('quiz'));//获取测验信息
			var question_list = quiz.questions;//获取测验中的所有试题
			var current_question = question_list[parseInt($.getData('current_question_number'))];//获取当前试题
			
			//本按钮消失
			$(this).hide();
			
			//对于选择题
			if(current_question.qtype == 'multichoice'){
				
				//再总体是否正确，显示答案反馈
				var fraction_array = $('ul li span.answer :nth-child(1)[selected]');//所有选中的选项
				var fraction_sum = 0;
				
				for(var i = 0;i<fraction_array.length;i++){
					fraction_sum += parseFloat($(fraction_array[i]).parent().attr('fraction'));		//比重和	，		
					$(fraction_array[i]).parent().find(".feedback").show();//显示选中选项的反馈
				}
				
						
				//把对的答案显示为对的，错的答案显示为错误的,清除事件响应
				$('ul li span.answer :nth-child(1)').removeClass('answer_selected').removeAttr('selected').attr('disabled','disabled');
				
				var answers = $('ul li span.answer :nth-child(1)');
				for(var i = 0;i<answers.length;i++){
					
					if(parseFloat($(answers[i]).parent().attr('fraction')) > 0) $(answers[i]).addClass('answer_checked_correct');
					if(parseFloat($(answers[i]).parent().attr('fraction')) == 0) $(answers[i]).addClass('answer_checked_incorrect');
				}
				
				
				
			}
			//对于匹配题
			else if(current_question.qtype == 'matching'){
				
				var fraction_sum = 0;
				var sub_questions = $('.sub_question_text_content li');//匹配题的子问题
				var total_number = 0 ;
				if(sub_questions.length > 0){
					for(var i = 0;i<sub_questions.length;i++){//对匹配题的子问题进行遍历
						var _array = $(sub_questions[i]).attr('answer_text').split(',');//某一子问题的所有答案集合
						total_number += _array.length ;//该匹配题的所有答案集合
						
						for(var j =0 ; j < _array.length ; j ++ ){//遍历该子问题的所有答案集合
							
							var temp = _array[j];//盖子问题的某一个答案
							var response = $('span',sub_questions[i]);//学生的答题情况
							
							for(var k = 0 ; k < response.length ; k++ ){
								
								if($(response[k]).attr('id')){
									if( temp == $(response[k]).attr('sub_answer_id')){
								
										$(response[k]).addClass('right_show');
										fraction_sum++;
										
									}else {
										
										$(response[k]).addClass('wrong_show');
									}
								}
								
							}
							
						}
						$('.feedback_sub').show();	
					}
				}
				fraction_sum = fraction_sum/total_number;				
			}
			//对于连线题
			else if(current_question.qtype == 'connection'){
				
				$('.line').css("stroke","rgb(255,0,0)");
				var sub_questions = current_question.options;
				
				var fraction_sum = 0;
				var total_number = 0 ;
				var left = $('.left');				
				
				var rightSel = $('#rightSel').attr('right');
				var rightLeft = rightSel.split(";");
				
				for(var j=0;j<rightLeft.length;j++){
					if(rightLeft[j]){
						var el = rightLeft[j].split(":");
						var lid = el[0];
						var rid = el[1].split("+");
						for(var i=0;i<rid.length;i++){
							if(rid[i]){
								$('#l'+lid+'r'+rid[i]).css("stroke","rgb(0,255,0)");
							}
						}						
						fraction_sum++;						
					}
				}
				total_number = left.length;
				
				fraction_sum = fraction_sum/total_number;		
				$('#rightSel').attr('right','')
			}else if(current_question.qtype == 'gapfilling'){	
								    
				var gap = new $.QuizQuestion.modGapfilling();
				gap.initData(current_question.options);//获取填空题的详细信息				
			    
			    var rightNum = 0;//正确题名的个数
			    var feedback = '';//反馈信息
			    var answer_display = $('.gap_answers');
				
				for(var i=0;i<answer_display.length;i++){					
					var gapid = answer_display[i].id.slice(9);
					var answer = $.trim($('#gapAnswer'+gapid).val());	
					var altAnswers = gap.getGap(gapid);
					console.log('开始匹配'+(i+1)+'题'+answer+'   '+altAnswers.length);	
					//匹配答案		
					for(var j = 0;j<altAnswers.length;j++){
								
						if(answer == altAnswers[j].answer_text){
								console.log('匹配成功');	
								$('#gapAnswer'+gapid).css("background-color","green");
								rightNum ++;
								break;								
						}else{								
							if(j==(altAnswers.length-1)){
								console.log('匹配失败');
								$('#gapAnswer'+gapid).css("background-color","red");										
							}
						}
					}
					feedback += '第'+(i+1)+'个空反馈：'+gap.getFeedback(gapid)+'<br/>';
				}
				fraction_sum = rightNum/answer_display.length;				
				
				$('#gap_feedback').html(feedback);
				$('#gap_feedback').show();
						
			}
			
			if(fraction_sum == 0){
			
				//显示错误反馈和再做一次操作按钮
				$('.incorrect_feedback').show();
				$('.again_button').show();
				
			}else if(fraction_sum > 0 && fraction_sum < 1){
			
				//显示部分正确反馈和再做一次操作按钮
				$('.partically_feedback').show();
				$('.again_button').show();
				
			}else if(fraction_sum == 1){
			
				//显示正确反馈和清除答案操作按钮
				$('.correct_feedback').show();
				$('.clear_button').show();
			}
			
		});
	}
	
	//清除答案
	var initAnswerClearEvent = function(){
	
		$('.clear_button').unbind().bind('click',function(){
			
			$.QuizQuestion.log('clear_button');
			var quiz = JSON.parse($.getData('quiz'));
			var question_list = quiz.questions;
			var current_question = question_list[parseInt($.getData('current_question_number'))];
			
			$(this).hide();
			$('.feedback').hide();
			
			/** 清空答题记录 **/
			var question_id = $('.question_content').attr('question_id');
			var question_attempt = JSON.parse($.getData('question_attempt'));
			
			//清空答题记录
			for(var i = 0;i<question_attempt.length;i++){
				
				if(question_attempt[i].question_id == question_id){
					
					question_attempt[i].response_summary = '';
					question_attempt[i].grade = 0;
					question_attempt[i].state = 'todo';
					question_attempt[i].response_summary = '';
					question_attempt[i].notes = null;
					question_attempt[i].timemodified = null;
					
					break;
				}
			}
			$.setData('question_attempt',JSON.stringify(question_attempt));
			
			if(current_question.qtype == 'multichoice'){
								
				$('ul li span.answer :nth-child(1)').removeClass('answer_checked_correct').removeClass('answer_checked_incorrect').removeAttr('disabled');
				
					
			}else if(current_question.qtype == 'matching'){
				
				//因为匹配题又进行重新加载了一次多以第二次会出现两个反馈
				$('.feedback_content').remove();
				
				var render  = new $.QuizQuestion.matching();
				
				if(render != null){
				
					$('.question_content').children().remove();
					var html =  render.render(current_question);
				
							
					$('.question_content').html(html);
			
					render.initEvent(current_question);
				}
			}else if(current_question.qtype == 'gapfilling'){				
				$('input').val('');
				$('input').css("background-color","white");
			}else if(current_question.qtype == 'connection'){				
				$('#paint').html('');
			}

			$('.feedback_content div').hide();
			
			//显示核对答案按钮
			$('.check_button').show();
			
		});
	}	
	
	//再打一次
	var initAnswerAgainEvent = function(){
		
		$('.again_button').unbind().bind('click',function(){
			
			$.QuizQuestion.log('again_button');
			var quiz = JSON.parse($.getData('quiz'));
			var question_list = quiz.questions;
			var current_question = question_list[parseInt($.getData('current_question_number'))];
			
			$(this).hide();
			
			/** 清空答题记录 **/
			var question_id = $('.question_content').attr('question_id');
			var question_attempt = JSON.parse($.getData('question_attempt'));
			
			for(var i = 0;i<question_attempt.length;i++){
				
				if(question_attempt[i].question_id == question_id){
										
					question_attempt[i].grade = 0;
					question_attempt[i].state = 'todo';
					question_attempt[i].response_summary = '';
					question_attempt[i].notes = null;
					question_attempt[i].timemodified = null;
					
					break;
				}
			}
			$.setData('question_attempt',JSON.stringify(question_attempt));
			
			if(current_question.qtype == 'multichoice'){
				
				
				$('ul li span.answer :nth-child(1)').removeClass('answer_checked_correct').removeClass('answer_checked_incorrect').removeAttr('disabled');
				
					
			}else if(current_question.qtype == 'matching'){
				$('.feedback_content').remove();
							
				var render  = new $.QuizQuestion.matching();
				if(render != null){
				
					$('.question_content').children().remove();
					var _html = render.render(current_question);				
												
					$('.question_content').html(_html);
			
					render.initEvent(current_question);
				}
			}else if(current_question.qtype == 'gapfilling'){				
				$('input').val('');
				$('input').css("background-color","white");
			}else if(current_question.qtype == 'connection'){
				$('#paint').html('');
			}
						
			$('.feedback_content div').hide();
			$('.feedback').hide();
			$('.feedback_sub').hide();
			$('.check_button').show();
			
		});		
	}	
			
}

//对于考试模式
$.QuizQuestion.examBehaviour = function(){

	var _this = this;
	
	var exam_time_limit = null;
	
	this.render = function(){
		
		var html = '';
		
		html += _this.renderPageButton();
		html += _this.renderSubmitButton();				
		
		return html;
	}
	
	this.renderTime = function(){
		
		$.QuizQuestion.log('renderTime');
		
		var html = '<div class="quiz_time"></div>';
		
		
		return html;
	}
	
	//上一页下一页
	this.renderPageButton = function(){
		
		$.QuizQuestion.log('_this.renderPageButton');
		
		var html = '';
		
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		
		if(current_question_number != 0)	html += '<a class="prev_page_button button_d conner10">上一页</a>';	
		if(current_question_number < (quiz.questions.length -1))	html += '<a class="next_page_button button_d conner10">下一页</a>';
		
		$.QuizQuestion.log(html);
		
		return html;
	}
	
	//提交按钮
	this.renderSubmitButton = function(){
		
		var html = '';
		
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		
		if(current_question_number == (quiz.questions.length -1))	html += '<a class="submit_button button_d conner10">提交</a>';
		
		
		return html;
	}
	
	
	this.initEvent = function(){
	
		initTimeEvent();
		_this.initPageEvent();
		_this.initSubmitEvent();
		
		$('.feedback_content div').hide();
	}
	
	
	var initTimeEvent = function(){
		
		if($.QuizQuestion.examInterval != null) clearInterval($.QuizQuestion.examInterval);

		intervalFunction();			 
		
		$.QuizQuestion.examInterval = setInterval(intervalFunction,1000);
		
	}
	
	
	var intervalFunction = function(){
		var quiz = JSON.parse($.getData('quiz'));
		var quiz_attempt = JSON.parse($.getData('quiz_attempt'));
		
		if($.getData('exam_time_limit')){
			
			exam_time_limit = parseInt($.getData('exam_time_limit'));
			
		}else{
			
			if(quiz_attempt.timefinish != null){
				
				exam_time_limit = parseInt(parseInt(quiz.timelimit) - (parseInt(quiz_attempt.timefinish)-parseInt(quiz_attempt.timestart)));
				
			}else{
				
				exam_time_limit = parseInt(quiz.timelimit);	
			} 
		}
		//检测时间，如果时间到了还没有到最后一道题，强制结束，设定成绩为空，进入summary页面，如果做到了，就正常提交
		if(exam_time_limit > 0){
			
			//设定屏幕倒计时时钟
			var hours = minutes = seconds = 0;
			
			hours = parseInt(exam_time_limit/3600);
			minutes = parseInt((exam_time_limit - hours*3600)/60);
			seconds = parseInt(exam_time_limit - (hours*3600) - (minutes*60));
			
			//$('.quiz_time').html(hours+':'+minutes+':'+ seconds);
			
			showTime(hours,minutes,seconds);
			exam_time_limit--;
			
			quiz_attempt.timefinish = parseInt(new Date().getTime()/1000);
			
			$.setData('exam_time_limit',exam_time_limit);
			$.setData('quiz_attempt',JSON.stringify(quiz_attempt));
			
		}else{
			
			exam_time_limit --;
			showTime(0,0,0);
			clearInterval($.QuizQuestion.examInterval);
			$.removeData('exam_time_limit');
			
			//模拟提交试卷
			_this.submitData();
			$.QuizQuestion.displayError('对不起，你的答题时间到啦！','summary.html');
			
		}
	}

	var showTime = function(hours,minutes,seconds){
		var _html = "";
		if(hours<10&&hours>=0)
			_html += "0" + hours;
		else
			_html += hours;
		_html += ":" ;
		
		if(minutes<10&&minutes>=0)
			_html += "0" + minutes;
		else
			_html += minutes;
		_html += ":" ;
		
		if(seconds<10&&seconds>=0)
			_html += "0" + seconds;
		else
			_html += seconds;
		
		$('.quiz_time').html(_html);
	}
	
	
	this.initPageEvent = function(){
	
		$('.prev_page_button').click(function(){
						
			//如果存在多媒体文件，就停止
			resetPlayer();
			//$('#exam_content').css('marginLeft',"1024px");
			
			
			var current_question_number = parseInt($.getData('current_question_number'));
		
			$.setData('current_question_number',current_question_number - 1);
			$.QuizQuestion.currentPage.reload();
			
		});
		
		$('.next_page_button').click(function(){
			
			//如果存在多媒体文件，就停止
			resetPlayer();
			
			
			var current_question_number = parseInt($.getData('current_question_number'));
		
			$.setData('current_question_number',current_question_number + 1);
			$.QuizQuestion.currentPage.reload();
			
		});
	}
	
	this.initSubmitEvent = function(){
	
		
		$('.submit_button').unbind().bind('click',function(){
			
			$.QuizQuestion.log('submit button');
			
			//如果存在多媒体文件，就停止
			resetPlayer();
			
			
			_this.submitData();
		});
	
	}
	
	this.submitData = function(){
			
		clearInterval();
		if($.getData('exam_time_limit')) $.removeData('exam_time_limit');
			
		//向PAD发送quiz_attempt数据
		var quiz = JSON.parse($.getData('quiz'));
		var quiz_attempt  = JSON.parse($.getData('quiz_attempt'));
		var question_attempt_list = JSON.parse($.getData('question_attempt'));
		
		//向PAD发送question_attempt数据，如果该试题没有回答，就模拟空记录加入到question_attempt中
		quiz = JSON.parse($.getData('quiz'));
		question_list = quiz.questions;
		
		
		quiz_attempt.submited = 1;
		quiz_attempt.timemodified = parseInt(new Date().getTime()/1000);
		quiz_attempt.timefinish = parseInt(new Date().getTime()/1000);
		quiz_attempt.sumgrades = 0;
		
		for(var m = 0;m<question_attempt_list.length;m++){
			
			quiz_attempt.sumgrades += question_attempt_list[m].grade;
		}
		
		
		for(var i = 0;i<question_list.length;i++){
			
			for(var j = 0;j<question_attempt_list.length;j++){
				
				if((question_list[i].id == question_attempt_list[j].question_id) && (question_attempt_list[j].state == 'todo')){
					
					var right_answer = '';
					
					if(question_list[i].options.qtype == 'multichoice'){
						for(var k = 0;k<question_list[i].options.answers.length;k++){
							
							if(question_list[i].options.answers[k].fraction != 0) right_answer += question_list[i].options.answers[k].answer + ',';
							
						}
					}else if(question_list[i].options.qtype == 'matching'){
						
						for(var k = 0;k<question_list[i].options.sub_questions.length;k++){
							
							right_answer += question_list[i].options.sub_questions[k].answer_text + ',';
							
						}
					}else if(question_list[i].options.qtype == 'gapfilling'){
						console.log('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! exam');	
					}
					
					question_attempt_list[j].right_answer = right_answer.substr(0,parseInt(right_answer.length-1));					
					question_attempt_list[j].response_summary = '';
					question_attempt_list[j].timemodified = parseInt(new Date().getTime()/1000);
					question_attempt_list[j].state = 'gradewrong';
					question_attempt_list[j].notes = ''; 
					
				}
			}	
		}
		
		$.setData('tmp_quiz_attempt',JSON.stringify(quiz_attempt));
		$.setData('tmp_question_attempt',JSON.stringify(question_attempt_list));
	
		if($.QuizQuestion.development == false && !$.getData('from_quiz')){
			
			//向PAD发送请求
			var request = new $.request();
			request.action = 'submit_record';
			request.params.quiz_id = quiz.id;
			request.params.quiz_attempt = Base64.encode(JSON.stringify(quiz_attempt));
			request.params.question_attempt = Base64.encode(JSON.stringify(question_attempt_list));
			request.params.quiz_attempt_id = quiz_attempt.id;
			request.params.finish_time = quiz_attempt.timefinish;
			request.sendRequest();
				
		}else{
			
			$.QuizQuestion.SyncAttemptData('submit_record',1);	
		}
		
		
	}	
}


$.QuizQuestion.assigenmentBehaviour = function(){

	var _this = this;
	
	var exam_time_limit = null;
						
	this.render = function(){
		
		var html = '';
				
		html += _this.renderPageButton();
		html += _this.renderSubmitButton();
		
		return html;
	}
	
	this.renderTime = function(){
		
		$.QuizQuestion.log('renderTime');
		
		var html = '<div class="quiz_time"></div>';
		
		return html;
	}
	
	this.renderPageButton = function(){
		
		$.QuizQuestion.log('_this.renderPageButton');
		
		var html = '';
		
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		
		if(current_question_number != 0)	html += '<a class="prev_page_button button_d conner10">上一页</a>';	
		if(current_question_number < (quiz.questions.length -1))	html += '<a class="next_page_button button_d conner10">下一页</a>';
		
		$.QuizQuestion.log(html);
		return html;
	}
	
	this.renderSubmitButton = function(){
		
		var html = '';
		
		var current_question_number = parseInt($.getData('current_question_number'));
		var quiz = JSON.parse($.getData('quiz'));
		
		if(current_question_number == (quiz.questions.length -1))	html += '<a class="submit_button button_d conner10">提交</a>';
		
		
		return html;
	}
	
	
	this.initEvent = function(){
	
		initTimeEvent();
		_this.initPageEvent();
		_this.initSubmitEvent();
	}
	
	
	var initTimeEvent = function(){
		
		if($.QuizQuestion.examInterval != null)	clearInterval($.QuizQuestion.examInterval);
	
		intervalFunction();			 
		
		$.QuizQuestion.examInterval = setInterval(intervalFunction,1000);
		
	}
	
	var intervalFunction = function(){
		
		
		var quiz = JSON.parse($.getData('quiz'));
		var quiz_attempt = JSON.parse($.getData('quiz_attempt'));
		
		if($.getData('exam_time_limit')){
			
			exam_time_limit = parseInt($.getData('exam_time_limit'));
			
		}else{
			
			if(quiz_attempt.timefinish != null){
				
				exam_time_limit = parseInt(parseInt(quiz.timeclose) - parseInt(quiz_attempt.timefinish));
				
			}else{
	
				exam_time_limit = parseInt(quiz.timeclose) - parseInt(new Date().getTime()/1000);
			} 
				
		}
		 
		
		//检测时间，如果时间到了还没有到最后一道题，强制结束，设定成绩为空，进入summary页面，如果做到了，就正常提交
		if(exam_time_limit > 0){
			
			//设定屏幕倒计时时钟
			var hours = minutes = seconds = 0;
			
			days = parseInt(exam_time_limit/(24*3600));
			hours = parseInt((exam_time_limit - (days*24*3600))/3600);
			minutes = parseInt((exam_time_limit - (days*24*3600) - (hours*3600))/60);
			seconds = parseInt(exam_time_limit - (days*24*3600) - (hours*3600) - (minutes*60));
			
			
			showTime(days,hours,minutes,seconds);	
			
			exam_time_limit--;
			
			quiz_attempt.timefinish = parseInt(new Date().getTime()/1000);
			
			$.setData('exam_time_limit',exam_time_limit);
			$.setData('quiz_attempt',JSON.stringify(quiz_attempt));
			
		}else{
			exam_time_limit --;
			showTime(0,0,0,0);
			
			if($.QuizQuestion.examInterval != null)	clearInterval($.QuizQuestion.examInterval);
			$.removeData('exam_time_limit');
			
			//模拟提交试卷
			_this.submitData();
			$.QuizQuestion.displayError('对不起，你的答题时间到啦！','summary.html');
			
		}
					
	}
	
	
	var showTime = function(days,hours,minutes,seconds){
		var _html = "";
		if(days != 0)
			_html += days + "天";
		if(hours<10&&hours>=0)
			_html += "0" + hours;
		else
			_html += hours;
		_html += ":" ;
		
		if(minutes<10&&minutes>=0)
			_html += "0" + minutes;
		else
			_html += minutes;
		_html += ":" ;
		
		if(seconds<10&&seconds>=0)
			_html += "0" + seconds;
		else
			_html += seconds;
		
		$('.quiz_time').html(_html);
	}
	
	
	this.initPageEvent = function(){
	
		$('.prev_page_button').click(function(){
			
			//如果存在多媒体文件，就停止
			resetPlayer();
			
			var current_question_number = parseInt($.getData('current_question_number'));
		
			$.setData('current_question_number',current_question_number - 1);
			$.QuizQuestion.currentPage.reload();
			
		});
		
		$('.next_page_button').click(function(){
			
			//如果存在多媒体文件，就停止
			resetPlayer();
			
			var current_question_number = parseInt($.getData('current_question_number'));
		
			$.setData('current_question_number',current_question_number + 1);
			$.QuizQuestion.currentPage.reload();
			
		});
	}
	
	this.initSubmitEvent = function(){
			
		$('.submit_button').unbind().bind('click',function(){
			
			$.QuizQuestion.log('submit button++++++++++++++++++++++=');
			
			//如果存在多媒体文件，就停止
			//resetPlayer();
			
			_this.submitData();
		});
	
	}
	
	this.submitData = function(){
		
		clearInterval();
		if($.getData('exam_time_limit')) $.removeData('exam_time_limit');
		
		//向PAD发送quiz_attempt数据
		var quiz = JSON.parse($.getData('quiz'));
		var quiz_attempt  = JSON.parse($.getData('quiz_attempt'));
		var question_attempt_list = JSON.parse($.getData('question_attempt'));
		
		//向PAD发送question_attempt数据，如果该试题没有回答，就模拟空记录加入到question_attempt中
		quiz = JSON.parse($.getData('quiz'));
		question_list = quiz.questions;
		
		
		quiz_attempt.submited = 1;
		quiz_attempt.timemodified = parseInt(new Date().getTime()/1000);
		quiz_attempt.timefinish = parseInt(new Date().getTime()/1000);
		quiz_attempt.sumgrades = 0;
		
		for(var m = 0;m<question_attempt_list.length;m++){
			
			quiz_attempt.sumgrades += question_attempt_list[m].grade;
		}
		
		
		for(var i = 0;i<question_list.length;i++){
			
			for(var j = 0;j<question_attempt_list.length;j++){
				
				if((question_list[i].id == question_attempt_list[j].question_id) && (question_attempt_list[j].state == 'todo')){

					var right_answer = '';					
					if(question_list[i].options.qtype == 'multichoice'){
						for(var k = 0;k<question_list[i].options.answers.length;k++){
							
							if(question_list[i].options.answers[k].fraction != 0) right_answer += question_list[i].options.answers[k].answer + ',';
							
						}
					}else if(question_list[i].options.qtype == 'matching'){
						
						for(var k = 0;k<question_list[i].options.sub_questions.length;k++){
							
							right_answer += question_list[i].options.sub_questions[k].answer_text + ',';
							
						}
					}else if(question_list[i].qtype == 'gapfilling'){						
						console.log('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! assiment');	
					}
					
					question_attempt_list[j].right_answer = right_answer.substr(0,parseInt(right_answer.length-1));
					question_attempt_list[j].response_summary = '';
					question_attempt_list[j].timemodified = parseInt(new Date().getTime()/1000);
					question_attempt_list[j].state = 'gradewrong';
					question_attempt_list[j].notes = ''; 
					
				}
			}	
		}
		
		$.setData('tmp_quiz_attempt',JSON.stringify(quiz_attempt));
		$.setData('tmp_question_attempt',JSON.stringify(question_attempt_list));
	
		if($.QuizQuestion.development == false && !$.getData('from_quiz')){
			
			//向PAD发送请求
			var request = new $.request();
			request.action = 'submit_record';
			request.params.quiz_id = quiz.id;
			request.params.quiz_attempt = Base64.encode(JSON.stringify(quiz_attempt));
			request.params.question_attempt = Base64.encode(JSON.stringify(question_attempt_list));
			request.params.quiz_attempt_id = quiz_attempt.id;
			request.params.finish_time = quiz_attempt.timefinish;
			request.sendRequest();	
			
		}else{
			
			$.QuizQuestion.SyncAttemptData('submit_record',1);	
		}		
	}	
}
