$.QuizQuestion.connectionPureWordTemplate = 'q_text';
$.QuizQuestion.connectionPicAndWordTemplate = 'q_pic_and_word';
$.QuizQuestion.connectionPicAndPicTemplate = 'q_pic_and_pic';
$.QuizQuestion.connectionPureWordConnectTemplate = 'q_text_connect';

$.QuizQuestion.connection = function() {

	var _this = this;
	var flag = true;

	var isLeft = false;//左侧内容是否选中
	var isRight = false;//右侧内容是否选中

	var leftId = '';//左侧选中元素的id
	var rightId = '';//右侧选中元素的id

	var userAnswer = new $.QuizQuestion.connection.modUserAnswer();//存储用户答案
	var selRinght = new $.QuizQuestion.connection.modSelRight();//存储已经中的右侧id

	var questions = '';
	var answers = new Array();//保存右侧答案顺序

	this.render = function(question_obj) {
		var html = '';

		if (question_obj != null) {

			html += '<div class="question_content" question_id = "'
					+ question_obj.id + '" grade_in_quiz="'
					+ question_obj.grade_in_quiz + '">';

			switch (question_obj.options.template) {

				case $.QuizQuestion.connectionPureWordTemplate :
				case $.QuizQuestion.connectionPureWordConnectTemplate :
					html += _this.renderPureWordTemplate(question_obj);
					break;
				case $.QuizQuestion.connectionPicAndWordTemplate :
					html += _this.renderPicAndWordTemplate(question_obj);
					break;
				case $.QuizQuestion.connectionPicAndPicTemplate :
					html += _this.renderPicAndPicTemplate(question_obj);
					break;
			}

			html += '</div>';
		}

		return html;
	}

	var renderQuestionText = function(question_obj) {

		var html = '';

		html += '<div class="question_text">' + question_obj.text + '</div>';

		return html;
	}

	//
	this.renderPureWordTemplate = function(question_obj) {

		$.QuizQuestion.log('renderPureWordTemplate');
		var html = '';
		//var answers = new Array();

		html += renderQuestionText(question_obj);

		if (parseInt(question_obj.options.shuffle_answers) == 1) {
			question_obj.options.sub_questions
					.sort($.QuizQuestion.shuffleArray);
		}

		questions = question_obj.options.sub_questions;

		html += '<div id="match"  style="margin:20px;float:left;height:600px">';
		//渲染左侧内容
		html += '<div class="match" id="left" style="float:left;height:600px">';
		html += this.renderLeft(question_obj);
		html += '</div>';

		//渲染画图板
		html += '<div class="match" id="paint" style="float:left;width:300px;height:600px"></div>';

		//渲染右侧内同
		html += '<div class="match" id="right" style="float:left;height:600px">';
		html += this.renderRight(question_obj);
		html += '</div>';
		html += '</div>';
		html += '<div id="rightSel"></div>';

		html += renderFeedBack(question_obj);

		return html;
	}

	//渲染左侧的内同
	this.renderLeft = function(question_obj) {
		var leftlen = question_obj.options.sub_questions.length;//左侧列表的长度	

		var html = '';
		html += '<ul class="match" style="list-style-type:none">';
		for (var i = 0;i < leftlen; i++) {
			html += '<li class="select left" id="left_' + (i + 1)
					+ '" style="height:' + (600 / leftlen) + 'px;line-height:'
					+ (600 / leftlen) + 'px;">';
			html += question_obj.options.sub_questions[i].question_text;
			html += '</li>';
		}
		html += '</ul>';

		return html;
	}
	//渲染右侧的内容
	this.renderRight = function(question_obj) {
		for (var i = 0;i < question_obj.options.sub_questions.length; i++) {
			for (var j = 0;j < question_obj.options.sub_questions[i].sub_answers.length; j++) {
				var temp = question_obj.options.sub_questions[i].sub_answers[j].answer_text;
				answers.push(temp);
			}
		}

		answers.sort($.QuizQuestion.shuffleArray);//将右侧选项打乱顺序
		var rightlen = answers.length;
		var html = '';
		html += '<ul class="match" style="list-style-type:none">';

		for (var i = 0;i < rightlen; i++) {

			html += '<li class="select right" id="right_' + (i + 1)
					+ '" style="height:' + (600 / rightlen) + 'px;line-height:'
					+ (600 / rightlen) + 'px;">';

			html += answers[i];

			html += '</li>';

		}
		html += '</ul>';

		return html;
	}
	//连线
	var paint = function(userAnswer, selRinght, question_obj) {
		var html = '<svg id="sv" width="300px" height="600px" version="1.1"xmlns="http://www.w3.org/2000/svg">';
		var x1, x2, y1, y2;
		// 划线		
		var leftlen = question_obj.options.sub_questions.length;

		var rightlen = answers.length;

		for (var i = 0;i < leftlen; i++) {

			var sel = userAnswer.getAnswer(i + 1);
			if (sel) {
				x1 = 0;
				y1 = i * (600 / leftlen) + (600 / (leftlen * 2));
				console.log('l ' + (i + 1) + '连接');
				for (var j = 0;j < sel.length; j++) {
					x2 = 300;
					y2 = (sel[j] - 1) * (600 / rightlen)
							+ (600 / (rightlen * 2));
					console.log('r ' + (sel[j]));
					html += '<line class="line" id="l'
							+ (i + 1)
							+ 'r'
							+ sel[j]
							+ '" x1="'
							+ x1
							+ '" y1="'
							+ y1
							+ '" x2="'
							+ x2
							+ '" y2="'
							+ y2
							+ '" style="stroke:rgb(0,0,255);stroke-width:6" onclick="click(evt)"/>';
				}
			}
		}

		html += '</svg>';

		$('#paint').html(html);

		return html;
	}
	//渲染反馈
	var renderFeedBack = function(question_obj) {

		var html = '';

		html += '<div class="feedback_content">';
		html += '<div class="correct_feedback" style="display:none">'
				+ question_obj.correct_feedback + '</div>';
		html += '<div class="partically_feedback" style="display:none">'
				+ question_obj.partically_correct_feedback + '</div>';
		html += '<div class="incorrect_feedback" style="display:none">'
				+ question_obj.incorrect_feedback + '</div>';
		html += '</div>';

		return html;
	}

	//初始化连线题的点击事件
	this.initPureWordTemplateEvent = function(question_obj) {

		$('.select').click(function() {
			//为了保证用户重新答题时缓存的数据清空
				if (!$('#paint').html()) {
					userAnswer = new $.QuizQuestion.connection.modUserAnswer();//存储用户答案
					selRinght = new $.QuizQuestion.connection.modSelRight();//存储已经中的右侧id					
				}
				var str = $(this).attr("id").split('_');
				var side = str[0];

				if (side == 'left') {
					console.log('left select');
					isLeft = true;
					leftId = str[1];
				} else {
					console.log('right select');
					isRight = true;
					rightId = str[1];
					//判断右侧是否已经选中，如果已经选中则返回
					if (selRinght.getSel(rightId)) {
						isRight = false;
						return;
					} else {
						selRinght.putSel(rightId);
					}
				}

				if (isLeft && isRight) {
					console.log('draw');
					var sel = userAnswer.getAnswer(leftId);
					if (sel) {
						for (var i = 0;i < sel.length; i++) {
							if (sel[i] == rightId) {
								return;
							}
						}
						sel.push(rightId);
					} else {
						sel = new Array();
						sel.push(rightId);
					}
					userAnswer.putAnswer(leftId, sel);

					paint(userAnswer, selRinght, question_obj);
					saveData();//保存用户的答题记录
					isRight = false;
				}

			});
		$('.line').die().live('click', function(event) {
			console.log(event.currentTarget.id);
			// 解析点击的连线的id
				var selLid = event.currentTarget.id.slice(1, 2);
				var selRid = event.currentTarget.id.slice(3, 4);
				console.log(selLid + '+++++' + selRid);
				//从用户的答题记录中删除该题		
				var sel = userAnswer.getAnswer(selLid);
				if (sel) {
					for (var j = 0;j < sel.length; j++) {
						//删除用户的答题记录
						if (sel[j] == selRid) {
							sel.splice(j, 1);
							selRinght.removeSel(selRid);
							paint(userAnswer, selRinght, question_obj);
							saveData();//保存用户的答题记录
						}
					}
				}
			});

	}

	this.renderPicAndWordTemplate = function(question_obj) {

		var html = '';

		html += renderQuestionText(question_obj);

		return html;
	}

	this.renderPicAndPicTemplate = function(question_obj) {

		var html = '';

		html += renderQuestionText(question_obj);

		return html;
	}

	this.initEvent = function(question_obj) {

		$.QuizQuestion.log('init question event');

		if ($.getData('review_question_attempt') && $.getData('view_status')
				&& $.getData('view_status') == 'review') {

			//为已经展现的DOM组件添加数据显示,回顾模式
			var question_attempt_list = JSON.parse($
					.getData('review_question_attempt'));

		} else if ($.getData('question_attempt')) {

			//为已经展现的DOM组件添加数据显示
			var question_attempt_list = JSON.parse($
					.getData('question_attempt'));

		}

		for (var i = 0;i < question_attempt_list.length; i++) {
			if (($('.question_content').attr('question_id') == question_attempt_list[i].question_id)
					&& question_attempt_list[i].state != 'todo') {

				pushData(question_attempt_list[i], question_obj);
			}
		}

		switch (question_obj.options.template) {

			case $.QuizQuestion.connectionPureWordTemplate :
			case $.QuizQuestion.connectionPureWordConnectTemplate :
				_this.initPureWordTemplateEvent(question_obj);
				break;
			case $.QuizQuestion.connectionPicAndWordTemplate :
				_this.initPicAndWordTemplateEvent();
				break;
			case $.QuizQuestion.connectionPicAndPicTemplate :
				_this.initPicAndPicTemplateEvent();
				break;
		}
	}

	var pushData = function(question_attempt_obj, question_obj) {
		alert('pushData');
	}

	var saveData = function() {

		$.QuizQuestion.log('saveData');

		var question_attempt_list = JSON.parse($.getData('question_attempt'));

		for (var i = 0;i < question_attempt_list.length; i++) {

			if ($('.question_content').attr('question_id') == question_attempt_list[i].question_id) {

				question_attempt_list[i] = editQuestionData(question_attempt_list[i]);
			}
		}

		$.setData('question_attempt', JSON.stringify(question_attempt_list));

	}

	var editQuestionData = function(question_attempt) {

		question_attempt.behaviour = $.getData('behaviour');
		question_attempt.question_summary = $('.question_text').html();

		/**
		 * 11,22,33
		 */
		question_attempt.notes = new Object();
		question_attempt.notes.questions = questions;//子问题
		question_attempt.notes.answers = answers;//子答案
		question_attempt.notes.ringht = $('#rightSel').attr('right');

		var sum_fraction = 0;
		var right_answer_text = new Array();
		//var sub_questions = $('.left');
		// var sub_answers = $('.right');

		var ringhtSel = '';
		for (var i = 0;i < questions.length; i++) {

			var result = true;
			var sel = userAnswer.getAnswer(i + 1);
			if (!sel) {
				continue;
			}
			//如果用户漏选或者多选则该子试题错误
			if (questions[i].sub_answers.length != sel.length) {
				continue;
			}
			var el = ':';
			//答案个数相同，现在判断是否全部一样
			for (var p = 0;p < questions[i].sub_answers.length; p++) {
				el += sel[p] + '+';
				if (!$.inArray(sel[p], questions[i].sub_answers)) {
					result = false;
					break;
				}
			}

			if (result == true) {
				ringhtSel += (i + 1) + el + ';';
				sum_fraction++;
			}
		}

		$('#rightSel').attr('right', ringhtSel);

		sum_fraction = sum_fraction / (i - 1);
		question_attempt.right_answer = right_answer_text;
		question_attempt.response_summary = userAnswer//用户答题记录;		

		question_attempt.timemodified = parseInt(new Date().getTime() / 1000);
		question_attempt.grade = parseInt($('.question_content')
				.attr('grade_in_quiz'))
				* sum_fraction;

		if (sum_fraction == 1) {

			question_attempt.state = 'graderight';

		} else if (sum_fraction < 1 && sum_fraction > 0) {

			question_attempt.state = 'gradeparticallyright';

		} else if (sum_fraction == 0) {

			question_attempt.state = 'gradewrong';

		}

		return question_attempt;
	}
}

//用户答题记录类
$.QuizQuestion.connection.modUserAnswer = function() {
	var _this = this;
	this.answers = new Array();//保存gap的答案

	this.initData = function(connection) {
		_this.answers = connection_obj.answers;
	}

	//获取个数
	this.size = function() {
		return this.answers.length;
	};

	//向MAP中增加元素（key, value) 
	this.putAnswer = function(_key, _value) {
		if (this.getAnswer(_key) != null) {
			this.removeAnswer(_key);
		}
		this.answers.push( {
			key : _key,
			value : _value
		});
	};

	//删除指定KEY的元素，成功返回True，失败返回False
	this.removeAnswer = function(_key) {
		var bln = false;
		try {
			for (i = 0;i < this.answers.length; i++) {
				if (this.answers[i].key == _key) {
					this.answers.splice(i, 1);
					return true;
				}
			}
		} catch (e) {
			bln = false;
		}
		return bln;
	};

	//获取指定KEY的元素值VALUE，失败返回NULL
	this.getAnswer = function(_key) {
		try {
			for (i = 0;i < this.answers.length; i++) {
				if (this.answers[i].key == _key) {
					return this.answers[i].value;
				}
			}
			return null;
		} catch (e) {
			return null;
		}
	};
}

//存储用户右侧已经选中的内容，从而保证右侧的一个内容不被左侧的两个不同的线连接
$.QuizQuestion.connection.modSelRight = function() {
	var _this = this;
	this.sel = new Array();//保存gap的答案

	this.initData = function(gapfilling_obj) {
		_this.sel = gapfilling_obj.sel;
	}

	//获取个数
	this.size = function() {
		return this.sel.length;
	};

	//向MAP中增加元素（key, value) 
	this.putSel = function(_key) {
		if (this.getSel(_key) != null) {
			this.removeSel(_key);
		}
		this.sel.push(_key);
	};

	//删除指定KEY的元素，成功返回True，失败返回False
	this.removeSel = function(_key) {
		var bln = false;
		try {
			for (i = 0;i < this.sel.length; i++) {
				if (this.sel[i] == _key) {
					this.sel.splice(i, 1);
					return true;
				}
			}
		} catch (e) {
			bln = false;
		}
		return bln;
	};

	//获取指定KEY的元素值VALUE，失败返回NULL
	this.getSel = function(_key) {
		try {
			for (i = 0;i < this.sel.length; i++) {
				if (this.sel[i] == _key) {
					return this.sel[i];
				}
			}
			return null;
		} catch (e) {
			return null;
		}
	};
}