$.QuizQuestion.gapfilling = function() {

	var _this = this;
	var gap_question = null;

	this.render = function(question_obj, quiz_obj) {
		gap_question = question_obj;
				
		var html = '';
		if (question_obj != null) {

			html += '<div class="question_content" question_id = "'
					+ question_obj.id + '" grade_in_quiz="'
					+ question_obj.grade_in_quiz + '">';
			html += _this.renderContent(question_obj, quiz_obj);
			html += '</div>';
		}
		return html;
	}

	var renderQuestionText = function(question_obj, quiz_obj) {

		var html = '';
		var quizTextFontSize = quiz_obj.textFontSize || '24px';
		html += '<div class="question_text" style="font-size:'+quizTextFontSize+'">' + question_obj.text + '</div>';
		return html;
	}

	var renderAnswers = function(question_obj, quiz_obj) {
		var html = '';
		//展示填空题的题干
		var content = question_obj.options.question_content;
		if (content != null) {
			var answercontentFontSize = quiz_obj.answercontentFontSize || '14px';
			html += '<div class="answer_content" style="font-size:'+answercontentFontSize+'">';
			html += content;
			html += '</div>';
		}
		return html;
	}

	var renderFeedBack = function(question_obj, quiz_obj) {

		var html = '';
		html += '<div class="feedback_content">';
		html += '<div class="gap_feedback" id="gap_feedback" style="display:none"></div>';
		html += '<div class="correct_feedback" style="display:none">'
				+ question_obj.correct_feedback + '</div>';
		html += '<div class="partically_feedback" style="display:none">'
				+ question_obj.partically_correct_feedback + '</div>';
		html += '<div class="incorrect_feedback" style="display:none">'
				+ question_obj.incorrect_feedback + '</div>';
		html += '</div>';

		return html;
	}

	//
	this.renderContent = function(question_obj, quiz_obj) {

		var html = '';
		html += renderQuestionText(question_obj, quiz_obj);//展示题名
		html += renderAnswers(question_obj, quiz_obj);//展示题目内容
		html += renderFeedBack(question_obj, quiz_obj);//展, quiz_obj示反馈  
		return html;
	}

	this.initEvent = function() {

		$.QuizQuestion.log('init question event');
		
		if ($.getData('review_question_attempt') && $.getData('view_status') && $.getData('view_status') == 'review') {
						
			// 为已经展现的DOM组件添加数据显示,回顾模式
			var question_attempt_list = JSON.parse($.getData('review_question_attempt'));

		} else if ($.getData('question_attempt')) {
		
			// 为已经展现的DOM组件添加数据显示
			var question_attempt_list = JSON.parse($.getData('question_attempt'));
						
		}
			
		if(question_attempt_list){
			
			for (var i = 0;i < question_attempt_list.length; i++) {
				
				if (($('.question_content').attr('question_id') == question_attempt_list[i].question_id) && question_attempt_list[i].state != 'todo') {										
					
					var user_answers = question_attempt_list[i].response_summary.answers;					
					pushData(question_attempt_list[i]);
					
					//增加数据回现										
					for (var j = 0;j < user_answers.length; j++) {
																			
							if(user_answers[j].value){
								$('#gap'+user_answers[j].key).replaceWith('<input class="gap_answers" id="gapAnswer'+ user_answers[j].key	+ '" value="'+user_answers[j].value+'"/>');														
							}else{
								$('#gap'+user_answers[j].key).replaceWith('<input class="gap_answers" id="gapAnswer'+ user_answers[j].key	+ '" value=""/>');														
							}
					}
					
				}else if($('.question_content').attr('question_id') == question_attempt_list[i].question_id && question_attempt_list[i].state == 'todo'){
					
					
					//如果是填空题,则对内容进行特殊处理 		
					var answer_display = $('.gap');
					var user_answers = new $.QuizQuestion.modUserAnswer();
					var right_answer = '';
										
					for (var j = 0;j < answer_display.length; j++) {
						
						var gapid = answer_display[j].id.slice(3);
						
						if ($('#gap' + gapid) != null) {
														
							// 用input替换内容中的button部分
							$('#gap' + gapid).replaceWith('<input class="gap_answers" id="gapAnswer'+ gapid	+ '" value=""/>');
						}
					
						//增加默认空的用户选项						 
						 user_answers.putAnswer(gapid,'');//保存用户答案
						
						
						//添加获取某个空的方法
						gap_question.options.getGap = function(_key) {
							try {
								for (var x = 0;x < this.answers.length; x++) {
									if (this.answers[x].key == _key) {
										return this.answers[x].value;
									}
								}
								return null;
							} catch (e) {
								return null;
							}
						};
					
																		
						var altAnswers = gap_question.options.getGap(gapid);
						
						//增加正确答案选项
						right_answer += '第'+(j+1)+'个空的备选正确答案：';						
						for (var k = 0;k < altAnswers.length; k++) {
							right_answer += '{'+altAnswers[k].answer_text + '} ';
						}
						right_answer += '；';
					}
					
					question_attempt_list[i].response_summary = new Object();
					question_attempt_list[i].response_summary.answers = user_answers.answers;	
					question_attempt_list[i].right_answer = right_answer;	
				}				
			}						
			
			$.setData('question_attempt',JSON.stringify(question_attempt_list));
		}

		initSaveEvent();
	}

	//初始化用户填写的答案保存事件
	var initSaveEvent = function() {

		$.QuizQuestion.log('init gapfilling question ');

		$('.gap_answers').blur(function() {
			$.QuizQuestion.log('.gap_answers');
			saveData();
		});

	}

	var pushData = function(question_attempt_obj) {

		$.QuizQuestion.log('pushData');

		if (question_attempt_obj.notes != null && question_attempt_obj.notes != '') {
			
			// 模拟试题答案顺序
			var answer_layout_array = question_attempt_obj.notes.answer_layout
					.split(',');

			for (var j = 0;j < answer_layout_array.length; j++) {

				var $li_answer = $('.answer_content ul li:has(.answer[answer_id="'
						+ answer_layout_array[j] + '"])');
				if ($li_answer.length > 0) {

					$li_answer.remove();
					$li_answer.appendTo($('.answer_content ul'));
				}
			}

			// 模拟试题序号
			var answer_numbers = $('.answer_number');

			// 模拟试题选项

		}
	}

	var saveData = function() {

		$.QuizQuestion.log('saveData');

		var question_attempt_list = JSON.parse($.getData('question_attempt'));

		for (var i = 0;i < question_attempt_list.length; i++) {
			if ($('.question_content').attr('question_id') == question_attempt_list[i].question_id) {
				question_attempt_list[i] = editQuestionData(question_attempt_list[i]);
			}
		}

		$.setData('question_attempt', JSON.stringify(question_attempt_list));

	}

	//保存用户的答题记录
	var editQuestionData = function(question_attempt) {

		question_attempt.behaviour = $.getData('behaviour');
		question_attempt.question_summary = "";
		
		
		
		var gap = gap_question.options;//获取填空题的详细信息
		//添加获取某个空的方法
		gap.getGap = function(_key) {
			try {
				for (var x = 0;x < this.answers.length; x++) {
					if (this.answers[x].key == _key) {
						return this.answers[x].value;
					}
				}
				return null;
			} catch (e) {
				return null;
			}
		};

		var rightNum = 0;//正确题名的个数
		question_attempt.notes = new Object();
		question_attempt.notes.answer_layout = '';
		
		var user_answers = new $.QuizQuestion.modUserAnswer();
		var sum_fraction = 0;		
		var right_answer = '';
		
		var answer_display = $('.gap_answers');
		
		for (var i = 0;i < answer_display.length; i++) {
			
			var gapid = answer_display[i].id.slice(9);
		
			var answer = $.trim($('#gapAnswer' + gapid).val());//用户答案
			var altAnswers = gap.getGap(gapid);
		
			//匹配答案
			
			for (var j = 0;j < altAnswers.length; j++) {
				if (answer == altAnswers[j].answer_text) {
							
					rightNum++;
					break;
				}				
			}
			user_answers.putAnswer(gapid,answer);//保存用户答案
			
			right_answer += '第' + (i + 1) + '个空的备选正确答案：';			
			for (var j = 0;j < altAnswers.length; j++) {
				right_answer += '{'+altAnswers[j].answer_text + '} ';
			}
			right_answer += '；';
		}
		
		sum_fraction = rightNum / answer_display.length;
				
		
		question_attempt.response_summary = user_answers;//用户答题纪录		
		question_attempt.right_answer = right_answer;
		

		question_attempt.notes.answer_layout = question_attempt.notes.answer_layout.substr(0, (question_attempt.notes.answer_layout.length - 1));

		question_attempt.timemodified = parseInt(new Date().getTime() / 1000);
		question_attempt.grade = parseInt($('.question_content').attr('grade_in_quiz'))* sum_fraction;//计算填空题成绩

		if (sum_fraction == 1) {
			
			question_attempt.state = 'graderight';

		} else if (sum_fraction < 1 && sum_fraction > 0) {

			question_attempt.state = 'gradeparticallyright';

		} else if (sum_fraction == 0) {

			question_attempt.state = 'gradewrong';

		}

		return question_attempt;
	}
}
//用户答题记录类
$.QuizQuestion.modUserAnswer = function(){
	
	var _this = this;
	this.answers = new Array();//保存gap的答案
	
	this.initData = function(gapfilling_obj){			
		_this.answers = gapfilling_obj.answers;
	}
	
	//获取个数
    this.size = function() {
        return this.answers.length;
    };
    
	//向MAP中增加元素（key, value) 
    this.putAnswer = function(_key, _value) {
    	if(this.getAnswer(_key) != null){
    		this.removeAnswer(_key);
    	}
    	
        this.answers.push( {
            key : _key,
            value : _value
        });
    };

    //删除指定KEY的元素，成功返回True，失败返回False
    this.removeAnswer = function(_key) {
        var bln = false;
        try {
            for (i = 0; i < this.answers.length; i++) {
                if (this.answers[i].key == _key) {
                    this.answers.splice(i, 1);
                    return true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    };

    //获取指定KEY的元素值VALUE，失败返回NULL
    this.getAnswer = function(_key) {
        try {
            for (i = 0; i < this.answers.length; i++) {
                if (this.answers[i].key == _key) {
                    return this.answers[i].value;
                }
            }
            return null;
        } catch (e) {
            return null;
        }
    };	 
}
//每一个空的信息类
$.QuizQuestion.modGapfilling = function(){	
	var _this = this;
	this.id = null;
	this.question_id = null;
	this.question_content = null;//题目的内容	
	this.answer_numbers = null;
	this.answers = new Array();//保存gap的答案
	this.feedback = new Array();//保存gap反馈
	
	this.initData = function(gapfilling_obj){
		_this.id = gapfilling_obj.id;
		_this.question_id = gapfilling_obj.question_id;
		_this.question_content = gapfilling_obj.question_content;
		_this.answer_numbers = gapfilling_obj.answer_numbers;		
		_this.answers = gapfilling_obj.answers;
		_this.feedback = gapfilling_obj.feedback;
	}
	
	/**********关于填空题答案的方法***********/
	//获取MAP元素个数
    this.size = function() {
        return this.answers.length;
    };
    
	//向MAP中增加元素（key, value) 
    this.putGap = function(_key, _value) {
    	if(this.getGap(_key) != null){
    		this.removeGap(_key);
    	}
        this.answers.push( {
            key : _key,
            value : _value
        });
    };

    //删除指定KEY的元素，成功返回True，失败返回False
    this.removeGap = function(_key) {
        var bln = false;
        try {
            for (i = 0; i < this.answers.length; i++) {
                if (this.answers[i].key == _key) {
                    this.answers.splice(i, 1);
                    return true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    };

    //获取指定KEY的元素值VALUE，失败返回NULL
    this.getGap = function(_key) {
        try {
            for (i = 0; i < this.answers.length; i++) {
                if (this.answers[i].key == _key) {
                    return this.answers[i].value;
                }
            }
            return null;
        } catch (e) {
            return null;
        }
    };	 
    
    /**********关于反馈的方法***********/
    //向MAP中增加元素（key, value) 
    this.putFeedback = function(_key, _value) {
    	if(this.getFeedback(_key) != null){
    		this.removeFeedback(_key);
    	}
        this.feedback.push( {
            key : _key,
            value : _value
        });
    };

    //删除指定KEY的元素，成功返回True，失败返回False
    this.removeFeedback = function(_key) {
        var bln = false;
        try {
            for (i = 0; i < this.feedback.length; i++) {
                if (this.feedback[i].key == _key) {
                    this.feedback.splice(i, 1);
                    return true;
                }
            }
        } catch (e) {
            bln = false;
        }
        return bln;
    };

    //获取指定KEY的元素值VALUE，失败返回NULL
    this.getFeedback = function(_key) {
        try {
            for (i = 0; i < this.feedback.length; i++) {
                if (this.feedback[i].key == _key) {
                    return this.feedback[i].value;
                }
            }
            return null;
        } catch (e) {
            return null;
        }
    };	 
}