$.QuizQuestion.matchingPureWordTemplate = 'q_text';
$.QuizQuestion.matchingPicAndWordTemplate = 'q_pic_and_word';
$.QuizQuestion.matchingPicAndPicTemplate = 'q_pic_and_pic';
$.QuizQuestion.matchingPureWordConnectTemplate = 'q_text_connect';

$.QuizQuestion.matching = function(){
	
	var _this = this;
	var flag = true ;
	
	this.render = function(question_obj, quiz_obj){
		answercontentFontSize = quiz_obj.answercontentFontSize || '18px';
		var html = '';
		
		if(question_obj != null){
			
			html += '<div class="question_content" question_id = "'+question_obj.id+'" grade_in_quiz="'+question_obj.grade_in_quiz+'">';
			
			switch(question_obj.options.template){
				
				case $.QuizQuestion.matchingPureWordTemplate:
				case $.QuizQuestion.matchingPureWordConnectTemplate:				
					html += _this.renderPureWordTemplate(question_obj, quiz_obj);
					break;
				case $.QuizQuestion.matchingPicAndWordTemplate:
					html += _this.renderPicAndWordTemplate(question_obj, quiz_obj);
					break;
				case $.QuizQuestion.matchingPicAndPicTemplate:
					html += _this.renderPicAndPicTemplate(question_obj, quiz_obj);
					break;
			}
			
			html += '</div>';
		}
		
		return html;
	}
	
	var renderQuestionText = function(question_obj, quiz_obj){
		
		var html = '';
		var quizTextFontSize = quiz_obj.textFontSize || '24px';
		html += '<div class="question_text" style="font-size:'+quizTextFontSize+'">'+question_obj.text+'</div>';
		
		return html;
	}
	
	//
	this.renderPureWordTemplate = function(question_obj, quiz_obj){
		
		$.QuizQuestion.log('renderPureWordTemplate');
		var html = '';
		var answers = new Array();
		
		html += renderQuestionText(question_obj, quiz_obj);
    
    	if(parseInt(question_obj.options.shuffle_answers) == 1){
    		
    		question_obj.options.sub_questions.sort($.QuizQuestion.shuffleArray);
    	}
    	
		//渲染子试题
		html += '<ul class="sub_question_text_content">';
		
		for(var i = 0;i<question_obj.options.sub_questions.length;i++){
			
			var temp = question_obj.options.sub_questions[i].sub_answers ;
			
			var temp_str = '';
			if($.isArray(temp)){
								
				for(var j = 0;j<temp.length;j++){
					
					temp_str += temp[j].id + ',';
				}
				
				temp_str = temp_str.substr(0,temp_str.length-1); 
			
			}
			html += '<li question_id="'+question_obj.options.sub_questions[i].id+'" answer_text="'+temp_str+'">';
			html += '<span style="font-size:'+answercontentFontSize+'">'+question_obj.options.sub_questions[i].question_text+'</span>';			
			html += '</li>';
			html += '<span class="feedback_sub" style="display:none">'+question_obj.options.sub_questions[i].feedback_sub+'</span>';
			
			answers.push(temp);
		}
		html += '</ul>';
		
		answers.sort($.QuizQuestion.shuffleArray);
		
		//渲染galley子试题答案  		
		if(answers.length > 0){
	
			html += '<ul class="sub_question_answer_content">';
			var num = 0;	
			for(var i = 0;i<answers.length;i++){
				
				for(var j = 0; j<answers[i].length;j++){
					
					num ++;
					html += '<li id="'+num+'" style="font-size:'+answercontentFontSize+'" sub_answer_id="'+answers[i][j].id+'">'+answers[i][j].answer_text+'</li>';
				
				}
				
			}
			
			html += '</ul></div>';
		}
		
  		html += renderFeedBack(question_obj);
  		
		return html;
	}
	
	
	var renderFeedBack = function(question_obj){
		
		var html  = '';
		
		html += '<div class="feedback_content">';
		html += '<div class="correct_feedback" style="display:none">'+question_obj.correct_feedback+'</div>';
		html += '<div class="partically_feedback" style="display:none">'+question_obj.partically_correct_feedback+'</div>';
		html += '<div class="incorrect_feedback" style="display:none">'+question_obj.incorrect_feedback+'</div>';
		html += '</div>';
		
		return html;
	}
	
	function initPureWordTemplateEventF(){
		
		var sUserAgent= navigator.userAgent.toLowerCase();
		var bIsAndroid= sUserAgent.match(/android/i) == "android"; 
		if(bIsAndroid){
			$('.sub_question_answer_content li').die().live('click',function(){
				var _this = $(this);
				$('.sub_question_answer_content').find('.qmatch_checked').css('border','1px solid #b9b9b9').removeClass('qmatch_checked');
				_this.css('border','2px solid #000').addClass('qmatch_checked');
			});

			$(".sub_question_text_content li").die().live('click',function(){
				var checkItem = $('.sub_question_answer_content').find('.qmatch_checked');
				
				if(checkItem.length>0){
					var checkItemSpan = $('<span style="font-size:'+answercontentFontSize+'" sub_answer_id="'+checkItem.attr('sub_answer_id')+'" question_id="'+$(this).attr('question_id')+'" id="'+$(checkItem).attr('id')+'">'+checkItem.text()+'</span>');
					checkItemSpan.appendTo($(this));
					checkItem.remove();
					saveData();
					initPureWordTemplateEventF();
				}
				
			});

			$('.sub_question_text_content li span').die().live('click',function(){
				if($(this).attr('sub_answer_id')){
					var checkItemLi = $('<li id="'+$(this).attr('id')+' sub_answer_id="'+$(this).attr('sub_answer_id')+'">'+$(this).html()+'</li>');
						checkItemLi.appendTo('.sub_question_answer_content');
						$(this).remove();
						saveData();	
						initPureWordTemplateEventF();
				}
			
			});
				
		}
		else{
			//galley中组件可以拖动
			$('.sub_question_answer_content li').draggable({
				cursor: "move", 
				containment:"document",
				revert:'invalid'
			});
			
			//question中可以接受answer组件
			$(".sub_question_text_content li").droppable({
				accept:".sub_question_answer_content li,.sub_question_text_content li span[question_id]",
				disabled:false,
				drop:function(event,ui){
					
					    var obj = ui.draggable;						  			    
						var html = '<span style="font-size:'+answercontentFontSize+'" sub_answer_id="'+$(obj).attr('sub_answer_id')+'" question_id="'+$(this).attr('question_id')+'" id="'+$(obj).attr('id')+'">'+$(obj).text()+'</span>';				
						
						ui.draggable.remove();
						
						$('.sub_question_answer_content li[id="'+$(obj).attr('id')+'"]').remove();	//0 代表隐藏这个子答案，非0代表显示这个子答案			
					    $(html).appendTo($(this)).animate({ width: "100px" ,height:"100px"}).draggable({cursor: "move",containment:"document", revert:'invalid'});
						
						saveData();
							
				}
				   
			});
			
			$(".sub_question_answer_content").droppable({
				accept:".sub_question_text_content li span[question_id]",
				disabled:false,
				drop:function(event,ui){
					   
					var obj = ui.draggable;
					var html = '<li id="'+$(obj).attr('id')+' sub_answer_id="'+$(obj).attr('sub_answer_id')+'">'+obj.html()+'</li>';					 
					var num = $(obj).attr('id') ;
					
					$('.sub_question_text_content li[question_id="'+$(this).attr('question_id')+'"] span[id="'+$(obj).attr('id')+'"]').remove();
					
					$(obj).remove();		
								
					$(html).appendTo($(this)).draggable({cursor: "move",containment:"document",revert:'invalid'});	
					
					
					saveData();										
				}
				
			});
		}
		
		saveData();
	} 
	//
	this.initPureWordTemplateEvent = initPureWordTemplateEventF;
	
 	this.renderPicAndWordTemplate = function(question_obj, quiz_obj){
   		
		var html = '';
				
		html += renderQuestionText(question_obj, quiz_obj);		
		
		return html;
   	}
   
   	this.renderPicAndPicTemplate = function(question_obj, quiz_obj){
  		
		var html = '';
		
		html += renderQuestionText(question_obj, quiz_obj);		
		
		return html;
   	}
  	
  	this.initEvent = function(question_obj){
		
		$.QuizQuestion.log('init question event');
		
		if($.getData('review_question_attempt') && $.getData('view_status') && $.getData('view_status') == 'review'){
			
			//为已经展现的DOM组件添加数据显示,回顾模式
			var question_attempt_list = JSON.parse($.getData('review_question_attempt'));
			
		}else if($.getData('question_attempt')){
			
			//为已经展现的DOM组件添加数据显示
			var question_attempt_list = JSON.parse($.getData('question_attempt'));
		
		}

		for(var i = 0;i<question_attempt_list.length;i++){
			if(($('.question_content').attr('question_id') == question_attempt_list[i].question_id) && question_attempt_list[i].state != 'todo'){
				
				pushData(question_attempt_list[i],question_obj);	
			}
		}
		

			
		switch(question_obj.options.template){
			
			case $.QuizQuestion.matchingPureWordTemplate:
			case $.QuizQuestion.matchingPureWordConnectTemplate:
				_this.initPureWordTemplateEvent();
				break;
			case $.QuizQuestion.matchingPicAndWordTemplate:
				_this.initPicAndWordTemplateEvent();
				break;
			case $.QuizQuestion.matchingPicAndPicTemplate:
				_this.initPicAndPicTemplateEvent();
				break;
		}
		
	}
	
	
	
	var pushData = function(question_attempt_obj,question_obj){
		
		
		if(question_attempt_obj.notes != null && question_attempt_obj.notes != ''){
			
			//模拟试题答案顺序
			var sub_question_layout_array = question_attempt_obj.notes.sub_question_layout.split(',');
			
			for(var j = 0;j<sub_question_layout_array.length;j++){
				
				var $li_sub_question = $('.sub_question_text_content li[question_id="'+sub_question_layout_array[j]+'"]');
				if($li_sub_question.length > 0){
					
					$li_sub_question.remove();
					$li_sub_question.appendTo($('.sub_question_text_content'));
				
					
				}
			}
			
			//模拟试题选项
			var response_summary_array = question_attempt_obj.response_summary;
			var sub_question_array = $('.sub_question_text_content li');
			
			var number = 0 ; 
			for(var i = 0;i<response_summary_array.length;i++){
				
				if($.isArray(response_summary_array[i]) && response_summary_array[i].length > 0){  
					
					var _array = response_summary_array[i];
										
					for(var j = 0 ; j < _array.length;j ++ ){
						
						number ++ ;						
						var html = '<span style="font-size:'+answercontentFontSize+'" sub_answer_id="'+_array[j]+'" question_id="'+$(sub_question_array[i]).attr('question_id')+'" id="'+number+'">';
						
						//获取子答案内容
						var sub_answer_content = '';
						for(var p = 0; p< question_obj.options.sub_questions.length;p++){
														
							var sub_answers = question_obj.options.sub_questions[p].sub_answers;
							
							for(var k = 0; k < sub_answers.length;k++){									
								
								if(sub_answers[k].id == _array[j]){
									
									sub_answer_content = sub_answers[k].answer_text;
								}
							}
							
						}
						html += sub_answer_content;
						
						
						//结束标签
						html += '</span>';
				
						
						$(sub_question_array[i]).append(html);					
						$('ul[class="sub_question_answer_content"] li[sub_answer_id='+_array[j]+']').remove();
						
					}
				}
				
			}
			$('.sub_question_text_content li span[question_id]').draggable({cursor: "move",containment:"document",revert:'invalid'});
			
			/*由于数据结构里面没有判断子答案是否选择，此处或许耗时比较多
			$('.question_content .sub_question_answer_content').html('');
			//$('.sub_question_text_content').after($('<ul class="sub_question_answer_content"></ul>'));
			var right_answer =  question_attempt_obj.right_answer.split(',');
			var array1 = new Array();
			var html = '';
			for(var i = 0 ; i < right_answer.length ; i ++ ){
				
				
				array1 = Base64.encode(right_answer[i]).split(',');
				for(var j =  0 ; j < array1.length ; j ++){
					
					var s = Base64.encode(array1[j]);
					
					for(var k = 0 ; k < answer.length ; k ++){
						if(s == answer[k]){
							
							break;
						}
					}
					if( k >= answer.length){
						$.QuizQuestion.log(k+'5');
						number ++ ;
						html += '<li id="'+number+'">'+s+'</li>';
						
						
					}
				}
			}
			**/ 
			//$('.sub_question_answer_content').append(html);
		
		}
		
	}
		
	
	var saveData = function(){
		
		$.QuizQuestion.log('saveData');
		
		var question_attempt_list = JSON.parse($.getData('question_attempt'));
			
			for(var i = 0;i<question_attempt_list.length;i++){
				
				if($('.question_content').attr('question_id') == question_attempt_list[i].question_id){
					
					question_attempt_list[i] = editQuestionData(question_attempt_list[i]);	
				}
			}
	
		 $.setData('question_attempt',JSON.stringify(question_attempt_list));
		 
		
	}
	
	var editQuestionData = function(question_attempt){
		
		question_attempt.behaviour = $.getData('behaviour');
		question_attempt.question_summary = $('.question_text').html();
		
		/**
		 * 11,22,33
		 */
		 var sub_questions = $('.sub_question_text_content li');
		 
		 question_attempt.notes = new Object();
		 question_attempt.notes.sub_question_layout = '';
		 
		 var sum_fraction = 0;
		 var right_answer_text = new Array();		 
	     var total_answer_number = 0;
	     var selected_answer_text = new Array();
	     
	     
		 for(var i = 0;i<sub_questions.length;i++){
		 	
		 	/**获取子试题正确答案**/
		 	var single_right_answer_text = $(sub_questions[i]).attr('answer_text').split(',');
		 	right_answer_text.push(single_right_answer_text);
		 	
		 			 	
		 	/**获取子试题用户回答**/
		 	if($('span[question_id]',sub_questions[i]).length > 0){
		 		
		 		var single_sub_question_answers = $(sub_questions[i]).children('span[question_id]');
		 		
		 		var single_selected_answer_text = new Array();
		 		for(var j = 0;j<single_sub_question_answers.length;j++){
		 				
		 				single_selected_answer_text.push($(single_sub_question_answers[j]).attr('sub_answer_id'));
		 				
		 		}
		 		selected_answer_text.push(single_selected_answer_text);		 		
				
		 	}else{
		 		
		 		// 
		 		selected_answer_text.push(new Array());
		 	}

			//记录试题布局
		 	question_attempt.notes.sub_question_layout += $(sub_questions[i]).attr('question_id') + ',';		 			 	
		 	
		 	
		    //计算单个子试题当中正确子答案		   		
  			var right_sub_answers = $(sub_questions[i]).attr('answer_text').split(',');  			
  			var user_sub_answers = $('span[question_id]',sub_questions[i]);
  			  	
  			//总体分数
  			var result = true;
  			
  			if(right_sub_answers.length != user_sub_answers.length)  result = false;
  			
  			if(result == true){
  				
  				//答案个数相同，现在判断是否全部一样
  				for(var p = 0;p < user_sub_answers.length; p++){
  					var ra = $(user_sub_answers[p]).attr('sub_answer_id');
  					if($.inArray(ra,right_sub_answers) == -1){
  						
  						result = false;
  						break;
  					}
  				}
  				
  			}
  			
  			if(result == true){
  				
  				sum_fraction ++;
  			}
		 }		 		
	     
		 sum_fraction = sum_fraction / (i-1);		 
		 question_attempt.right_answer = right_answer_text;
		 question_attempt.response_summary = selected_answer_text;
		 question_attempt.notes.sub_question_layout = question_attempt.notes.sub_question_layout.substr(0, question_attempt.notes.sub_question_layout.length-1);
		
		 
		 question_attempt.timemodified = parseInt(new Date().getTime()/1000);
		 question_attempt.grade = parseInt($('.question_content').attr('grade_in_quiz'))*sum_fraction;
		 
		
		 if(sum_fraction == 1){
		 	
		 	question_attempt.state = 'graderight';
		 		
		 }else if(sum_fraction < 1 && sum_fraction > 0){
		 	
		 	question_attempt.state = 'gradeparticallyright';
		 	
		 }else if(sum_fraction == 0){
		 	
		 	question_attempt.state = 'gradewrong';
		 	
		 }
		 
		 return question_attempt;
	}
}