$.QuizQuestion.answerNumbers = new Object();
$.QuizQuestion.answerNumbers.abc = new Array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');
$.QuizQuestion.answerNumbers.ABC = new Array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
$.QuizQuestion.multichoicePureWordTemplate = 'q_text';
$.QuizQuestion.multichoiceTextWithPicLeftTemplate = 'q_media_center';
$.QuizQuestion.multichoiceTextWithPicCenterTemplate = 'q_media_right';
$.QuizQuestion.multichoiceAnswerPurePic = 'a_media';

 $.QuizQuestion.multichoice = function(){
	
	var _this = this;
	this.current_template = $.QuizQuestion.multichoicePureWordTemplate;
	
	
	this.render = function(question_obj, quiz_obj){
		var html = '';
		
		if(question_obj != null){
			
			html += '<div class="question_content" style=" height:auto;" question_id = "'+question_obj.id+'" grade_in_quiz="'+question_obj.grade_in_quiz+'">';
			
			_this.current_template = question_obj.options.template;

			switch(question_obj.options.template){
				
				case $.QuizQuestion.multichoicePureWordTemplate:
					html += _this.renderTextPureWordsTemplate(question_obj, quiz_obj);
					break;
				case $.QuizQuestion.multichoiceTextWithPicLeftTemplate:
					html += _this.renderTextWithPicCenterTemplate(question_obj, quiz_obj);
					break;
				case $.QuizQuestion.multichoiceTextWithPicCenterTemplate:
					html += _this.renderTextWithPicRightTemplate(question_obj, quiz_obj);
					break;
				case $.QuizQuestion.multichoiceAnswerPurePic:
					html += _this.renderAnswerPurePicTemplate(question_obj, quiz_obj);
					break;
			}
			
			html += '</div>';
		}
		
		return html;
	}	
	
	var renderQuestionText = function(question_obj, quiz_obj){
		
		var html = '';
		var quizTextFontSize = quiz_obj.textFontSize || '24px';
		html += '<div class="question_text" style="font-size:'+quizTextFontSize+'">'+question_obj.text+'</div>';
		
		return html;
	}
	
	var renderQuestionCenterMedia = function(question_obj, quiz_obj){
		
		var html = '';
		
		if($.getData('base_question_path')){
			
			var base_path = $.getData('base_question_path');
			base_path += question_obj.id+'/';
			
		}else{
			var base_path = $.getData('base_path');
			var quiz_id = JSON.parse($.getData('quiz')).id;
			base_path += quiz_id+'/'+question_obj.id+'/';
		}
		
		if(question_obj.options.text_media != null && question_obj.options.text_media_type != null){

			//显示答案主体
			switch(question_obj.options.text_media_type){
			
			case 'image':
				html += '<img class="question_text_center_media" src="'+base_path+'image/'+question_obj.options.text_media+'"  width="100px" height="100px"/>';		
				break;
			case 'audio':
				html += '<audio class="question_text_center_media" src="'+base_path+'audio/'+question_obj.options.text_media+'" type="audio/mp3" /></audio>';
/*				html += '<audio src="'+base_path+'audio/'+question_obj.options.text_media+'" controls="controls"></audio>';
*/				break;
			case 'video':
				html += '<video class="question_text_center_media"  src="'+base_path+'video/'+question_obj.options.text_media+'" type="video/mp4" /></video>';
				/*html += '<video src="'+base_path+'video/'+question_obj.options.text_media+'" controls="controls"></video>';*/
				break;		
			}
		}
		
		return html;
	}
	
	var renderQuestionRightMedia = function(question_obj, quiz_obj){
		
		var html = '';
		if($.getData('base_question_path')){
			
			var base_path = $.getData('base_question_path');
			base_path += question_obj.id+'/';
			
		}else{
			var base_path = $.getData('base_path');
			var quiz_id = JSON.parse($.getData('quiz')).id;
			base_path += quiz_id+ '/'+question_obj.id+'/';
		}
		
		if(question_obj.options.text_media != null && question_obj.options.text_media_type != null){
			
		//显示答案主体
		switch(question_obj.options.text_media_type){
			
			case 'image':
				html += '<img class="question_text_right_media" src="'+base_path+'image/'+question_obj.options.text_media+'"  width="100px" height="100px"/>';		
				break;
			case 'audio':
				html += '<audio class="question_text_right_media" src="'+base_path+'audio/'+question_obj.options.text_media+'" type="audio/mp3" /></audio>';
/*				html += '<audio src="'+base_path+'audio/'+question_obj.options.text_media+'" controls="controls"></audio>';
*/				break;
			case 'video':
				html += '<video class="question_text_right_media" src="'+base_path+'video/'+question_obj.options.text_media+'" type="video/mp4" /></video>';
/*				html += '<video src="'+base_path+'video/'+question_obj.options.text_media+'" controls="controls"></video>';
*/				break;
			}
		}
		
		return html;		
		
	}
	
	var renderAnswers = function(question_obj, quiz_obj){
		
		var html = '';
		
		//显示试题答案
		var answers = question_obj.options.answers;
		
		if($.isArray(answers) && answers.length >0){
			
			//答案乱序
			if(question_obj.options.shuffle_answers == 1) answers.sort($.QuizQuestion.shuffleArray); 
			var answercontentFontSize = quiz_obj.answercontentFontSize || '14px';
			html += '<div class="answer_content"><ul style="font-size:'+answercontentFontSize+'">';
			
			for(var i = 0;i<answers.length;i++){
				
				html += '<li>';
				
				html += renderSingleAnswer(question_obj.id,question_obj.options,answers[i],i);
				html += '</li>';
			}
			html += '</ul></div>';			
		}
		
		return html;
	}
	
	var renderSingleAnswer = function(question_id,options,answer_obj,i){
			
		var html = '';
		
		if($.getData('base_question_path')){
			
			var base_path = $.getData('base_question_path');
			base_path += question_id+'/';
			
		}else{
			var base_path = $.getData('base_path');
			var quiz_id = JSON.parse($.getData('quiz')).id;
			base_path += quiz_id+'/'+question_id+'/';
		}		
		
		html += '<span class="answer" answer_id="'+answer_obj.id+'" fraction="'+answer_obj.fraction+'">';
		
		//显示操作框
		if(options.single == 1){
			
			html += '<span class="answer_radio_button conner50"></span>';
			
		}else{

			 html += '<span class="answer_checkbox_button"></span>';
		}
		
		//显示序号
		if(options.answer_numbers == 'abc') html += '<span class="answer_number">'+$.QuizQuestion.answerNumbers.abc[i]+'</span>';
		if(options.answer_numbers == 'ABC') html += '<span class="answer_number">'+$.QuizQuestion.answerNumbers.ABC[i]+'</span>';
		if(options.answer_numbers == '123') html += '<span class="answer_number">'+parseInt(i+1)+'</span>';
		
		//显示答案主体
		switch(options.answer_media_type){
 		
 		case 'image':
 			html += '<img class="answer_image" src="'+base_path+'image/'+answer_obj.answer+'"  width="100px" height="100px"/>';		
 			break;
 		case 'audio':
 			html += '<audio class="answer_audio" src="'+base_path+'audio/'+answer_obj.answer+'" type="audio/mp3" /></audio>';
 			break;
 		case 'video':
 			html += '<video class="answer_video" src="'+base_path+'video/'+answer_obj.answer+'" type="video/mp4" /></video>';
 			break;
 		default:
 			html += '<span class="answer_text">'+answer_obj.answer+'</span>';
 			break;
 		}
 		html += '<span class="feedback" style="display:none">'+answer_obj.feedback+'</span>';
 		
		return html;		
	}
	
	var renderFeedBack = function(question_obj){
		
		var html  = '';
		
		html += '<div class="feedback_content">';
		html += '<div class="correct_feedback" style="display:none">'+question_obj.correct_feedback+'</div>';
		html += '<div class="partically_feedback" style="display:none">'+question_obj.partically_correct_feedback+'</div>';
		html += '<div class="incorrect_feedback" style="display:none">'+question_obj.incorrect_feedback+'</div>';
		html += '</div>';
		
		return html;
	}
	
	//
	this.renderTextPureWordsTemplate = function(question_obj, quiz_obj){
		
		var html = '';
		
		html += renderQuestionText(question_obj, quiz_obj);
		html += renderAnswers(question_obj, quiz_obj);
		html += renderFeedBack(question_obj);
		
		return html;
	}
	
 	this.renderTextWithPicCenterTemplate = function(question_obj, quiz_obj){
   		
		var html = '';
				
   		html += renderQuestionText(question_obj, quiz_obj);
   		html += renderQuestionCenterMedia(question_obj, quiz_obj);
		html += renderAnswers(question_obj, quiz_obj);
		html += renderFeedBack(question_obj);
				
		return html;
   	}
   
   	this.renderTextWithPicRightTemplate = function(question_obj, quiz_obj){
  		
		var html = '';
		 		
   		html += renderQuestionText(question_obj, quiz_obj);
   		html += renderQuestionRightMedia(question_obj, quiz_obj);
		html += renderAnswers(question_obj, quiz_obj);
		html += renderFeedBack(question_obj);
				
		return html;
   	}
   
   	this.renderAnswerPurePicTemplate = function(question_obj, quiz_obj){
  		
		var html = '';
		 		
   		html += renderQuestionText(question_obj, quiz_obj);
		html += renderAnswers(question_obj, quiz_obj);
		html += renderFeedBack(question_obj);
				
		return html;
  	}
  	
  	this.initEvent = function(){
		
		$.QuizQuestion.log('init question event');
		
		if($.getData('review_question_attempt') && $.getData('view_status') && $.getData('view_status') == 'review'){
			
			//为已经展现的DOM组件添加数据显示,回顾模式
			var question_attempt_list = JSON.parse($.getData('review_question_attempt'));
			
		}else if($.getData('question_attempt')){
			
			//为已经展现的DOM组件添加数据显示
			var question_attempt_list = JSON.parse($.getData('question_attempt'));
		
		}

		for(var i = 0;i<question_attempt_list.length;i++){
			if(($('.question_content').attr('question_id') == question_attempt_list[i].question_id) && question_attempt_list[i].state != 'todo'){
				
				pushData(question_attempt_list[i]);	
			}
		}
		
		if($('.answer_radio_button').length > 0){
			
			$.QuizQuestion.log('init multichoice question radio event');
			
			initRadioChooseButtonEvent();
			
		}else if($('.answer_checkbox_button').length > 0){
			
			$.QuizQuestion.log('init multichoice question checkbox event');
			
			initCheckboxChooseButtonEvent();
		}
		
		
			
	
		
	}
	
	var initRadioChooseButtonEvent = function(){
   		
   		$.QuizQuestion.log('init multichoice question radio event 2');
   		
   		$('.answer_radio_button').click(function(){
   			
   			$.QuizQuestion.log('.answer_radio_button');
   			
   			if($(this).attr('disabled') == 'disabled') return;
   			
   			//去除其他兄弟节点的选中标志
   			$('.answer_content ul li span :nth-child(1)').removeClass('answer_selected');
   			$('.answer_content ul li span :nth-child(1)').removeAttr('selected');
   			
   			
   			//本身添加选中标志
   			$(this).addClass('answer_selected');   			
   			$(this).attr('selected','selected');
   			
   			saveData();
   			
   		});
   	
   }
   
   var initCheckboxChooseButtonEvent = function(){
   	
   		$('.answer_checkbox_button').toggle(function(){
   			
   			$.QuizQuestion.log('.answer_checkbox_button');
   			
   			if($(this).attr('disabled') == 'disabled') return;
   			
   			$(this).addClass('answer_selected').attr('selected','selected');	
   			
   			saveData();	
   			
   		},function(){
   			
   			if($(this).attr('disabled') == 'disabled') return;
   			
   			$(this).removeClass('answer_selected').removeAttr('selected');
   			
   			saveData();
   		});
   		
	}
	
	var pushData = function(question_attempt_obj){
		
		$.QuizQuestion.log('pushData');
		
		if(question_attempt_obj.notes != null && question_attempt_obj.notes != ''){
			//模拟试题答案顺序
			var answer_layout_array = question_attempt_obj.notes.answer_layout.split(',');
			
			for(var j = 0;j<answer_layout_array.length;j++){
				
				var $li_answer = $('.answer_content ul li:has(.answer[answer_id="'+answer_layout_array[j]+'"])');
				if($li_answer.length > 0){
					
					$li_answer.remove();
					$li_answer.appendTo($('.answer_content ul'));
				
					
				}
			}
			
			//模拟试题序号
			var answer_numbers = $('.answer_number');
			var current_question = JSON.parse($.getData('quiz')).questions[parseInt($.getData('current_question_number'))];
			
			for(var i = 0;i<answer_numbers.length;i++){
			
				if(current_question.options.answer_numbers == 'abc') $(answer_numbers[i]).html($.QuizQuestion.answerNumbers.abc[i]);
				if(current_question.options.answer_numbers == 'ABC') $(answer_numbers[i]).html($.QuizQuestion.answerNumbers.ABC[i]);
				if(current_question.options.answer_numbers == '123') $(answer_numbers[i]).html(i);
			
			}
			
			//模拟试题选项
			var response_summary_array = question_attempt_obj.response_summary.split(',');
			for(var i = 0;i<response_summary_array.length;i++){

				var total_answer = $('.answer');
				
				for(var j = 0;j<total_answer.length;j++){
					if($(total_answer[j]).attr('answer_id') == response_summary_array[i]){
											
						$(total_answer[j]).children('span:first').addClass('answer_selected').attr('selected','selected');
							
					}
				}
			}
		}
		
	}
	
	var saveData = function(){
		
		$.QuizQuestion.log('saveData');
		
		var question_attempt_list = JSON.parse($.getData('question_attempt'));
			
			for(var i = 0;i<question_attempt_list.length;i++){
				
				if($('.question_content').attr('question_id') == question_attempt_list[i].question_id){
					
					question_attempt_list[i] = editQuestionData(question_attempt_list[i]);	
				}
			}
	
		 $.setData('question_attempt',JSON.stringify(question_attempt_list));
		 
		
	}
	
	var editQuestionData = function(question_attempt){
		
		question_attempt.behaviour = $.getData('behaviour');
		question_attempt.question_summary = $('.question_text').html();

		
		 var answers = $('.answer');
		 
		 question_attempt.notes = new Object();
		 question_attempt.notes.answer_layout = '';
		 
		 var right_answer_text = '';
		 var selected_answer_text = '';
	     var sum_fraction = 0;
		 
		 for(var i = 0;i<answers.length;i++){
		 	
		 	question_attempt.notes.answer_layout += $(answers[i]).attr('answer_id') + ',';

		 		if(parseFloat($(answers[i]).attr('fraction')) != 0){
		 			
		 			right_answer_text += $(answers[i]).attr('answer_id') + ',';
		 			
		 		}
		 	
			 	if($(answers[i]).children('.answer_number').prev().attr('selected') == 'selected'){
			 		
			 		selected_answer_text += $(answers[i]).attr('answer_id') + ',';
			 	    sum_fraction += parseFloat($(answers[i]).attr('fraction'));
			 	    
			 	}
				 			 		
		 }
		 
		 question_attempt.right_answer = right_answer_text.substr(0,(right_answer_text.length-1));
		 question_attempt.response_summary = selected_answer_text.substr(0,(selected_answer_text.length-1));
		 	
		 question_attempt.notes.answer_layout = question_attempt.notes.answer_layout.substr(0,(question_attempt.notes.answer_layout.length-1));
		
		 question_attempt.timemodified = parseInt(new Date().getTime()/1000);		 
		 question_attempt.grade = parseInt($('.question_content').attr('grade_in_quiz'))*sum_fraction;
		
		 if(sum_fraction == 1){
		 	
		 	question_attempt.state = 'graderight';
		 		
		 }else if(sum_fraction < 1 && sum_fraction > 0){
		 	
		 	question_attempt.state = 'gradeparticallyright';
		 	
		 }else if(sum_fraction == 0){
		 	
		 	question_attempt.state = 'gradewrong';
		 	
		 }
		 
		 return question_attempt;
	}
}